    TITLE "BIOS_V.ASM" - BIOS Video-service, obslun rutinky pro ovldn videa.
    .8086                               ; Linkuje se pro 80 86
    PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









    COMMENT @
 

    Nzev souboru   :   BIOS_V.ASM
    Datum prav     :   01.04.96
    Verze programu  :   3.07
    (c) Copyright   :   1995,96 by NST 32 , Medo Zdenk junior

  @

Knihovna_NST32  SEGMENT PARA PUBLIC 'CODE' USE16
                ASSUME CS:Knihovna_NST32

    PUBLIC __bv_get_video_page   ; EXTRN  __bv_get_video_page   :PROC :NEAR
    PUBLIC __bv_set_video_page   ; EXTRN  __bv_set_video_page   :PROC :NEAR
    PUBLIC __bv_get_video_mode   ; EXTRN  __bv_get_video_mode   :PROC :NEAR
    PUBLIC __bv_get_cursor_pos   ; EXTRN  __bv_get_cursor_pos   :PROC :NEAR
    PUBLIC __bv_set_cursor_pos   ; EXTRN  __bv_set_cursor_pos   :PROC :NEAR
    PUBLIC __bv_set_cursor_size  ; EXTRN  __bv_set_cursor_size  :PROC :NEAR






;
;
;   Popis funkce    :   Peti aktuln strnku videa.
;   
;
;   Voln (nap.)  :   call    __bv_get_video_page     ; Zjisti aktuln strnku Videa
;   
;
;   Vstup          :   BH = slo strnky
;   
;
;   Mn registry   :   Flags, BX
;   
;
;

 __bv_get_video_page    PROC  NEAR
    push    ax
    call    __bv_get_video_mode             ; Zjisti aktuln md Videa
    pop     ax
    retn                                    ; Nvrat NEAR
 __bv_get_video_page    ENDP






;
;
;   Popis funkce    :   Nastav novou aktuln strnku videa.
;   
;
;   Voln (nap.)  :   mov     bh, slo strnky
;       call    __bv_set_video_page     ; Nastav novou strnku Videa
;
;   Mn registry   :   Flags
;   
;
;

 __bv_set_video_page    PROC  NEAR
    push    ax
    mov     ah, 05h                         ; Nastav novou strnku
    mov     al, bh                          ; Page
    int     10h
    pop     ax
    retn                                    ; Nvrat NEAR
 __bv_set_video_page    ENDP






;
;
;   Popis funkce    :   Peti aktuln md videa.
;   
;
;   Voln (nap.)  :   call    __bv_get_video_mode     ; Zjisti aktuln md Videa
;   
;
;   Vstup          :   AL = Aktuln md
;       AH = Poet znak na dek
;                       BH = slo strnky
;
;   Mn registry   :   Flags, AX, BX
;   
;
;

 __bv_get_video_mode    PROC  NEAR
    mov     ah, 0Fh                         ; Nati aktuln md
    int     10h
    retn                                    ; Nvrat NEAR
 __bv_get_video_mode    ENDP






;
;
;   Popis funkce    :   Peti aktuln nastaven kurzoru.
;   
;
;   Voln (nap.)  :   call    __bv_get_cursor_pos     ; Zjisti aktuln pozici kurzoru
;   
;
;   Vstup          :   CH = Poten linka kurzoru
;       CL = Koncov linka kurzoru
;                       DH = dek
;                       DL = Sloupec
;
;   Mn registry   :   Flags, CX, DX
;   
;
;

 __bv_get_cursor_pos    PROC  NEAR
    push    ax bx
    call    __bv_get_video_page                ; Zjisti aktuln strnku Videa
    mov     ah, 03h                         ; Peti polohu kurzoru
    int     10h
    pop     bx ax
    retn                                    ; Nvrat NEAR
 __bv_get_cursor_pos    ENDP






;
;
;   Popis funkce    :   Nastav nov pozice kurzoru.
;   
;
;   Voln (nap.)  :   mov     dh, dek               ; Pozice v dku
;       mov     dl, Sloupec             ; Pozice v sloupci
;                       call    __bv_set_cursor_pos     ; Nastav novou pozici kurzoru
;
;   Mn registry   :   Flags
;   
;
;

 __bv_set_cursor_pos    PROC  NEAR
    push    ax bx
    call    __bv_get_video_page             ; Zjisti aktuln strnku Videa
    mov     ah, 02h                         ; Nastav polohy kurzoru
    int     10h
    pop     bx ax
    retn                                    ; Nvrat NEAR
 __bv_set_cursor_pos    ENDP






;
;
;   Popis funkce    :   Nastav novou velikost kurzoru.
;   
;
;   Voln (nap.)  :   mov     ch, Po.                ; Poten linka kurzoru
;       mov     cl, End.                ; Koncov linka kurzoru
;                       call    __bv_set_cursor_size    ; Nastav velikost kurzoru
;
;   Mn registry   :   Flags
;   
;
;

 __bv_set_cursor_size   PROC  NEAR
    push    ax
    mov     ah, 01h                         ; Nastav velikost kurzoru
    int     10h
    pop     ax
    retn                                    ; Nvrat NEAR
 __bv_set_cursor_size   ENDP



Knihovna_NST32  ENDS
END
