   TITLE Ovldn pamti CMOS. (plat pouze pro AT)
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   CMOS_RW.ASM
  Datum prav    :   01.09.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __read_cmos          ; EXTRN __read_cmos           :PROC :NEAR
   PUBLIC __write_cmos         ; EXTRN __write_cmos          :PROC :NEAR

   EXTRN  __pause_ms           :PROC :NEAR  ; {PAUSE_MS.LIB}
   EXTRN  __cpu_pause          :PROC :NEAR  ; {CPU_PAUS.LIB}


;                     Ŀ
;                     {     Tabulka parametr  CMOS    }
;                     


;                    { Reln as }
;' 00 h - Sekundy relnch hodin
;' 01 h - Sekundy budku
;' 02 h - Minuty relnho asu
;' 03 h - Minuty budku
;' 04 h - Hodiny relnho asu
;' 05 h - Hodiny budku
;
;' 06 h - Den relnho asu v tdnu (1=Nedle)
;' 07 h - Den relnho asu v msci
;' 08 h - Msc relnho asu
;' 09 h - Rok relnho asu
;
;' 0A h - 10100110B   'Stavov registr A hodin relnho asu
;'        ĴĴ
;'             > Dlc initel (0110) pro dliku kmitotu genertoru
;'                   impuls (0110 uruje frekvenci 1024 kHz a peruovac
;'                   as 976,562 mikrosekund.
;'          
;'          > 22-stupov dlika (010) nastavuje zkladn frekvenci
;'                    tae hodin relnho asu (010 je 32,768 kHz zkladna)
;'        
;'        > Intern blokovn (0=povolen pstup k hodinm)
;
;' 0B h - 00000110B   'Stavov registr B hodin relnho asu
;'        
;'        > Zmna na letn as (poten nastaven 0=standartn
;'              as - bez zmny na letn as, 1=pechod na letn as -
;'              posledn nedli v dubnu dojde k posunu asu z 1:59 na
;'              3:00 a posledn nedli v jnu pejde as z 1:59 na 1:00)
;'        
;'        > 12-hodinov nebo 24-hodinov cyklus (poten
;'               nastaven  je 1=24hod.cyklus)
;'        
;'        > BCD kd (poten nastaven 1=BCD)
;'        
;'        > Genertor impuls (poten nastaven 0=vypnuto)
;'        
;'        > Generace peruen pi zpisu auktalizovanho
;'                  asu (poten nastaven 0=vypnuto)
;'        
;'        > Peruen od budku (poten nastaven 0=vypnuto)
;'        
;'        > Periodick peruen (poten nastaven 0=vypnuto),
;'                    frekvence peruen je nastaviteln v registru A, bity.0-3
;'        
;'        > Intern blokovn (poten nastaven 0=povolen
;'                     pstup k hodnotm)
;
;' 0C h - 00000000B   'Stavov registr C hodin relnho asu
;'        ĴĴ
;'              > Nevyuito
;'            
;'            > Jednotliv nvst pro peruen (IRQF - peruen
;'                     povoleno, PF-peruen od tae, AF-peruen od
;'                     budku, UF-peruen po modifikaci)
;'
;
;' 0D h - 10000000B   'Stavov registr D hodin relnho asu
;'        Ĵ
;'              > Nevyuito
;'        
;'        > Informace RTC jsou platn (stav 1), stav 0 indikuje
;'                     poruchu v napjen RTC


;              { Konfiguran informace }

;' 0E h - 00000000B   'POST (Power On Self Test) diagnostick informace
;'        
;'         > Nevyuito
;'        
;'        > POST kontrola genertoru relnho asu:
;'                     0 - Reln as je platn
;'                     1 - Reln as je neplatn
;'        
;'        > Kontrola inicializace pevnho disku:
;'                      0 - Inicializace probhla sprvn
;'                      1 - Inicializace neprobhla sprvn
;'        
;'        > Zmna velikosti pamti pi POST:
;'                       0 - velikost pamti souhlas s nastavenou hodnotou
;'                       1 - velikost pamti nesouhlas s nastavenou hodnotou
;'        
;'        > Platnost nastaven konfigurace:
;'                        0 - POST probhl sprvn
;'                        1 - POST neprobhl sprvn
;'        
;'        > Kontroln souet CMOS RAM:
;'                         0 - kontroln souet je platn
;'                         1 - kontroln souet je neplatn
;'        
;'        > Kontrola napjen RTC:
;'                          0 - RTC je napjen
;'                          1 - vpadek napjen RTC


;' 0F h - Diagnostika pro Reset (ShutDown), jednotliv informan bity
;'        tvo hodnotu, kter definuje dvod restartu a nslednou innost:
;'        0   - Tepl restart systmu (Ctrl-Alt-Del), POST se neprovede
;'        1   - Restart po definovn velikosti pamti
;'        2   - Restert po proveden testu pamti
;'        3   - Restart po chyb parity (parita 1 nebo 2)
;'        4   - Restart s poadavkem startu Loaderu
;'        5   - Restart s intern kontrolou a dlouhm skokem na adr. 0467h
;'        6,7,8 - Restart po proveden testu chrnnho reimu procesoru
;'        9   - Restart po proveden blokovho penosu z Extended pamti, resp.
;'              do Extended pamti
;'        10  - Restart po nvratu z chrnnho reimu, pm dlouh skok
;'              na adresu 0467h


;                { Disketov jednotky }

;' 10 h - 00000000B    Typ instalovanch disketovch jednotek
;'        ĴĴ
;'              > Typ druh disketov jednotky (tab.disket 1)
;'           
;'           > Typ prvn disketov jednotky (tab.disket 1)
;'
;'    tab.disket 1:    0000  Jednotka nen instalovna
;'                     0001  48  TPI, 2 str., 40 stop,  9 sekt.,  360 KB
;'                     0010  96  TPI, 2 str., 80 stop, 15 sekt.,  1,2 MB
;'                     0011  96  TPI, 2 str., 80 stop,  9 sekt.,  720 KB
;'                     0100  135 TPI, 2 str., 80 stop, 18 sekt., 1,44 MB
;'                     0101-1111 Rezervovno

;                      { Harddisky }

;' 11 h - Rezervovno
;' 12 h - 00000000B    Typ pevnho disku
;'        ĴĴ
;'              > Typ prvnho pevnho disku (tab.hdd 1)
;'           
;'           > Typ druhho pevnho disku (tab.hdd 1)


;          Poznmka: Tabulka byla porvrzena pozdji, proto me nastat
;                    situace,e nkter typy ROM BIOS maj tabulku disk
;                    dosti odlinou. Tato tabulka je firemn IBM.
;                         (PC/AT Technical Reference, 1984)

;                      Byty Typ Stop Hlav WRPc Land Kapacita
;'    tab.hdd 1:       0000   --- Disk nen instalovn ---
;'                     0001  1  306   4   128  305  10.6  MB
;'                     0010  2  615   4   300  615  21.4  MB
;'                     0011  3  515   6   300  615  32.1  MB
;'                     0100  4  940   8   512  940  65.4  MB
;'                     0101  5  940   6   512  940  49.0  MB
;'                     0110  6  615   4   ---  615  21.4  MB
;'                     0111  7  462   8   256  511  32.1  MB
;'                     1000  8  733   5   ---  733  31.9  MB
;'                     1001  9  900   15  ---  901  117.5 MB
;'                     1010  10 820   3   ---  820  21.4  MB
;'                     1011  11 855   5   ---  855  37.2  MB
;'                     1100  12 855   7   ---  855  52.0  MB
;'                     1101  13 306   8   128  319  21.3  MB
;'                     1110  14 733   7   ---  733  44.4  MB
;'                     1111  15  - Odkaz na dal typy disk -

;           { Informace o instalovanm vybaven }
;' 13 h - Rezervovno
;' 14 h - 00000000B   'Informace o instalovanm vybaven
;'        
;'           > Bit ptomnosti disketovch jednotek
;'                      0 - jednotky nejsou instalovny
;'                      1 - jednotky jsou instalovny
;'           
;'           > Bit ptomnosti matematickho koprocesoru
;'                       0 - koprocesor nen instalovn
;'                       1 - koprocesor je instalovn
;'           
;'           > Nevyuito
;'          
;'          
;'          
;'          > Primrn VIDEO-adaptr
;'                         00 - Rezervovno (grafick0 adaptry s mapovnm
;'                                           video-pamti, EGA,PGA,VGA atd.)
;'                         01 - CGA v textovm reimu 40x25
;'                         10 - CGA v textovm reimu 80x25
;'                         11 - MDA (monochrom nebo Hercules)
;'         
;'         > Poet instalovanch disketovch jednotek
;'                          00 - Je instalovna jedna mechanika
;'                          01 - Jsou instalovny dv mechaniky
;'                          11 - rezervovno
;'

;                 { Velikost pamti }
;' 15 h - Vel.zkladn operan pamti (LO bajt)
;' 16 h - Vel.zkladn operan pamti (HI bajt)
;          Poznmka: Platn jsou pouze tyto velikosti pamti:
;                    0100h - 256 KB systmov pamti
;                    0200h - 512 KB systmov pamti
;                    0280h - 640 KB systmov pamti

;' 17 h - Vel.rozujc pamti (LO bajt)
;' 18 h - Vel.rozujc pamti (HI bajt)
;          Poznmka: Platn jsou pouze naobky 512KB


;                     { Harddisky }
;' 19 h - 00000000B    Typ pevnho disku lo I  - vy ne 14 (Tabulka II.)

; ... voln

;' 1A h - 00000000B    Typ pevnho disku lo II - vy ne 14 (Tabulka II.)

;                      Bajt   Typ Stop Hlav WRPc Land Kapacita
;'    tab.hdd 2:       00h    16  612  4    ---  633  20.3  MB
;'                     01h    17  612  5    300  977  40.5  MB
;'                     02h    18  977  7    ---  977  56.7  MB
;'                     03h    19  1024 7    512  1023 59.5  MB
;'                     04h    20  733  5    300  732  30.4  MB
;'                     05h    21  733  7    300  732  42.5  MB
;'                     06h    22  733  5    300  733  30.4  MB
;'                     07h    23  306  4    0    336  10.1  MB
;          Poznmka: Tato tabulka byla dodvna s ROM BIOSem dodvnm k
;                    15.11.1985. Dal doplky ji nejsou standartn pro PC/AT,
;                    ale byly dodvny s prvnmy modely IBM PS/2.


;                 { Pomocn zznamy }
;' 1B h  a  2D h  - Rezervovno
;' 2E h  - Kontroln souet (word) adr.10h-20h  (HI bajt)
;' 2F h  - Kontroln souet (word) adr.10h-20h  (LO bajt)

;' 30 h  - (LO) Fyzicky nalezen velikost roziujc pamti v POST -
;' 31 h  - (HI)  - s touto velikos potaj vechny funkce BIOSu (INT 15)

;' 32 h  - BCD datum stolet pro ten a zpis pomoc funkce BIOS

;' 33 h  - 00000000B   ' Dodaten informace
;'         Ĵ
;'               > Pouito pro SETUP proceduru
;'         
;'         > Instalovno rozen IBM 128 KB RAM
;                      0 - Rozen neinstalovno
;                      1 - Rozen instalovno

;' 34 h  a  3F h  - Nevyuito IBM, u jinch vrobc BIOSu vyuvno
;'                   pro zpis hesla










;'
;' Popis funkce  : Tato procedura pete vybran bajt z CMOS pamti
;' 
;
;' Voln(nap.) :  mov  al, Adr.           ; Adr.v CMOS pro vbr bajtu
;'    call __read_cmos        ; Peti data z CMOS
;
;' Vstup        :  AL = Obsah vloenho pamovho msta
;' 
;
;' Mn registry :  Flags, AX
;' 
;
;'  

__read_cmos  PROC  NEAR
     out    70h, al                         ; Vyber adresu v AL
     call   __cpu_pause                     ; asov prodleva CPU (5x JMP $+2)
     in     al, 71h                         ; Nati do AL z bajt z CMOSky
     retn                                   ; Nvrt NEAR
__read_cmos  ENDP







;'
;' Popis funkce  : Tato procedura pete vybran bajt z CMOS pamti
;' 
;
;' Voln(nap.) :  mov  ah, Bajt           ; Nov parametr pro CMOS
;'    mov  al, Adr.           ; Adr.v CMOS pro uloen bajtu
;'                  call __write_cmos       ; Ulo data do CMOS
;
;' Mn registry :  Flags, AX
;' 
;
;'

__write_cmos  PROC  NEAR
     out    70h, al                         ; Vyber adresu v AL
     call   __cpu_pause                     ; asov prodleva CPU (5x JMP $+2)
     xchg   ah, al                          ; Proho reg.
     out    71h, al                         ; Ulo bajt do CMOS
     retn                                   ; Nvrt NEAR
__write_cmos  ENDP


Knihovna_NST32  ENDS
END
