   TITLE Detekce na typu procesoru ( CPU 80 x86 )
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   D_CPU.ASM
  Datum prav    :   01.03.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }

' Popis funkce  :  Tato procedura testuje typ procesoru.
' 

' Voln(nap.) :  call __detect_cpu        ; Test typu procesoru
' 

' Vrac        :   AX = 00                  ; Je to 8086
'    AX = 01                  ; neobsazeno (pro 186)
'                  AX = 02                  ; Je to 80 286
'                  AX = 03                  ; Je to 80 386
'                  AX = 04                  ; Je to 80 486
'                  AX = 05                  ; neobsazeno (pro PENTIUM)

' Mn registry :  AX,   Flags, BX, DX, BP
' 

'@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __detect_cpu         ; EXTRN __detect_cpu          :PROC :NEAR


__detect_cpu  PROC  NEAR
     xor    dx, dx                          ; slo procesoru
     mov    bp, sp                          ; Ulo aktuln hodnotu zsobnku
     sub    sp, 10                          ; Simulace vloen deseti bajt
                                            ;  (kli zarovnvn pi testu 486)

;             { Test na CPU 8086 }
;'       Podle programtorsk perliky BAJT 12/93 str. 139

     pushf                                  ; Ulo FLAGs
     pop    ax                              ;   - do AX
     mov    bx, ax                          ; Uschovej pro test 80286

     and    ax, 0FFFH                       ; Vynuluj bity 12-15
     push   ax
     popf                                   ; AX do Flags

     pushf                                  ; Znovu peti pznaky
     pop    ax
     and    ax, 0F000H                      ; Testuj, zda jsou
     cmp    ax, 0F000H                      ; - bity 12-15 nastaveny
     je     CPU_OK                          ; Je to XT 8086 ...

;           { Test na CPU 80 186 }
     inc    dx                              ; slo procesoru 80186

;           { Test na CPU 80 286 }
     inc    dx                              ; slo procesoru 80286
     or     bx, 0F000H                      ; Nastav bity 12-15
     push   bx
     popf                                   ; BX do Flags

     pushf
     pop    bx
     test   bx, 0F000H                      ; Testuj, zda jsou bity 12-15 nastaveny
     jz     CPU_OK                          ; Je to AT 80286 ...

;           { Test na CPU 80 386 }
     .386
     inc    dx                              ; slo procesoru 80386
     and    sp, not 3                       ; Zarovnej SP, aby nedolo k chyb AC
     push   eax ecx                         ; Ulo reg.

     pushfd                                 ; Ulo EFlags do EAX
     pop    eax
     mov    ecx, eax                        ; Uschovej EFlags pro porovnn
     xor    eax, 40000H                     ; Neguj bit 18 (AC)
     push   eax
     popfd
     pushfd
     pop    eax
     cmp    eax, ecx                        ; Testuj, zda byl bit 18 zmnn
     pop    ecx eax                         ; Obnov reg.
     je     CPU_OK                          ; Je to AT 80386 ...

;           { Test na CPU 80 486 }
     inc    dx                              ; slo procesoru 80486

;                 { CPU_OK }
CPU_OK:
     .8086
     mov    sp, bp                          ; Obnov pvodn SP (zmil-li jej test)
     mov    ax, dx                          ; slo procesoru
     retn                                   ; Nvrat NEAR
__detect_cpu  ENDP

Knihovna_NST32  ENDS
END
