   TITLE Test na ptomnost, poppad typ HDD (jen pro AT Bus - IDE)
;        Podle Programtorsk Perliky BAJT 10/92 str.132
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek








   COMMENT @
{

  Nzev souboru  :   D_HDD.ASM
  Datum prav    :   01.09.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __detect_hdd         ; EXTRN __detect_hdd          :PROC :NEAR
   PUBLIC __hdd_type           ; EXTRN __hdd_type            :PROC :NEAR
   PUBLIC &__hdd_type          ; EXTRN &__hdd_type           :WORD
   PUBLIC &__comand_status     ; EXTRN &__comand_status      :WORD
   PUBLIC &__data_register     ; EXTRN &__data_register      :WORD
   PUBLIC &__digital_output    ; EXTRN &__digital_output     :WORD




;                     Ŀ
;                     {     Tabulka parametr  HDD     }
;                     
&__hdd_type   DW 00     ; (+00) Konstanta 0A5Ah
              DW 00     ; (+02) Poet cylindr na disku
              DW 00     ; (+04) Poet odstranitelnch cylindr
              DW 00     ; (+06) Poet hlav
              DW 00     ; (+08) Poet neformtovanch bajt na stop
              DW 00     ; (+10) Poet neformtovanch bajt na sektoru
              DW 00     ; (+12) Poet sektor na stop
              DW 00     ; (+14) Poet bajt v oblasti mezi sektory
              DW 00     ; (+16) Poet bajt v synchronizanm poli
              DW 00     ; (+18) Konstanta 0000h

              DW 10 dup(0)      ; (+20) Sriov slo

              DW 00     ; (+40) Typ kontrolry
              DW 00     ; (+42) Velikost vnitnho bufferu v 512-bajtovch blocch
              DW 00     ; (+44) Poet bajt ECC pi operaci dlouhho ten/zpisu

              DW 4 dup (0)      ; (+46) Verze frimwaru kontrolru
              DW 20 dup(0)      ; (+54) Typ pevnho disku

              DW 00     ; (+94)  Poet sektor bhem interruptu
              DW 00     ; (+96)  Pznak penosu dvojtch slov

              DW 207 dup(0)      ; (+98) Rezerva





&__comand_status   DW 01F7h      ; Pznakov a stavov registr disku
;'bit.      00000000             ; Pi ten registru '_comand_status'
;'          
;'          > Chyba pedel operace                       - ERR
;'          > Bit. je ve stavu H, po kad otce          - IDX
;'          > Pi operaci s daty dolo k opraviteln chyb - CORR
;'          > Disk je pipraven k penosu dat              - DRQ
;'          > Operace hledn dokonena                    - DRQ
;'          > Chyba zpisu dat                             - DWF
;'          > Disk pipraven k operaci                     - DRDY
;'          > Disk provd njaku inost                   - BSY

&__data_register   DW 01F0h       ; Datov registr disku
&__digital_output  DW 03F6h       ; Digitln vstupn registr
;'bit.      00000000              ; Pi ten registru '&__digital_output'
;'          
;'          > nepouito
;'          > Povolen peruen (irq 14)                  - ien
;'          > Reset disku                                  - SRST
;'          > nepouito
;'          > nepouito
;'          > nepouito
;'          > nepouito
;'          > nepouito







;'
;' Popis funkce  : Tato procedura testuje ptomnost HDD.
;' 
;
;' Voln(nap.) :  call __detect_hdd        ; Test na ptomnost HDD
;' 
;
;' Vstup        :  CH = Max. slo stopy (10.bit.hodnota, horn dva bity v CL)
;'    CL = Max. slo sektoru
;'                  DH = Max. slo hlaviky
;'                  DL = Poet pipojench pevnch disk na adii
;'
;'                  Je-li CF=1, pak nastala chyba
;'                  AH = Stav operace
;
;' Mn registry :  Flags, AX, CX, DX
;' 
;
;'

__detect_hdd  PROC  NEAR
     mov    ah, 08h                         ; Nati parametry HDD
     mov    dl, 80h                         ; HDD 'C:'
     int    13h
     retn                                   ; Nvrt NEAR
__detect_hdd  ENDP






;'
;' Popis funkce  : Tato procedura testuje typ HDD.
;'   Pedpokladem je e je disk na AT Busu (IDE).
;'                 Poet bajt na sektoru je standartn 512.
;'                 Vpoet fyzivk velikosti disku (poet neformtovanch bajt
;'                          na cylindru + neformtovanch bajt na sektoru +
;'                          synchronizan bajty + adr. + CRC souty atd. ...)
;
;' Cylindry*Hlavy*Sektory na Cylindru*Bajty na stopu = Kapacita HDD disku
;
;
;' Voln(nap.) :  call __hdd_type         ; Test na ptomnost HDD
;' 
;
;' Vstup        :  ES:DI = Tabulka parametr HDD
;' 
;
;' Mn registry :  AX, CX, DX, DI, ES
;' 
;
;'

__hdd_type  PROC  NEAR
     pushf                                  ; Ulo FLAGs
     push   ds                              ; Ulo reg.
     cli                                    ; Zaka Extern peruen
     mov    ax, cs
     mov    ds, ax                          ; DS <= CS
     mov    es, ax                          ; ES <= CS

     mov    al, 00000100B                   ; Pkaz pro RESET disku
     mov    dx, word ptr [&__digital_output]; Reg.   pro RESET disku
     out    dx, al                          ; RESET disku
     xor    al, al                          ; Pkaz pro shozen RESETu
     out    dx, al                          ; odRESETovn disku

     mov    dx, word ptr [&__comand_status] ; Adr. adie-COMMAND/STATUS port
Test_Busy:in al, dx                         ; ten STATUSu po RESETu disku
     test   al, 10000000B                   ; Test, zda-li je disk BUSY
     jnz    Test_Busy                       ; Pokud je disk BUSY, sko ...

     cld                                    ; Smr plnn etzce
     mov    di, OFFSET &__hdd_type          ; Adr.kam budou ukldny data HDD
     push   di                              ; Ulo adr. Tabulky HDD
     mov    cx, 0080h                       ; Velikost tabulky
     mov    dx, word ptr [&__comand_status] ; Adr. adie-COMMAND/STATUS port
     mov    al, 0ECh                        ; dc bajt pro zskn parametr
     out    dx, al                          ; Zapsn pkazu do portu

Test_DRQ:in al, dx                          ; ten STATUSU
     test   al, 00001000B                   ; Test na pipravenost dat - DRQ
     jz     Test_DRQ                        ; Pokud nejsou data pipravena, sko ...
     push   dx                              ; Ulo reg.
     mov    dx, word ptr [&__data_register] ; Adr. DATA portu
     in     ax, dx                          ; Peten dat z portu
     pop    dx                              ; Obnova reg. DX
     stosw                                  ; Ulo parametr do tabulky
     loop   Test_DRQ                        ; Napl celou tabulku

     mov    al, 00000100B                   ; Pkaz pro RESET disku
     mov    dx, word ptr [&__digital_output]; Reg.   pro RESET disku
     out    dx, al                          ; RESET disku
     xor    al, al                          ; Pkaz pro shozen RESETu
     out    dx, al                          ; odRESETovn disku

     pop    di                              ; Obnov adr. Tabulky HDD
     pop    ds                              ; Obnov reg.
     popf                                   ; Obnov FLAGs
     retn                                   ; Nvrt NEAR
__hdd_type  ENDP


Knihovna_NST32  ENDS
END
