   TITLE Detekce koprocesoru INTEL 80xx7
   .8086                               ; Linkuje se pro 80 86
   .8087                               ;  i pro koprocesor
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek








   COMMENT @
{

  Nzev souboru  :   D_NPU.ASM
  Datum prav    :   01.03.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }

' Popis funkce  :  Tato procedura testuje ptomnost koprocesoru.
'    Pro detekci pouv jak BIOS, tak i vlast detekci ...

' Voln(nap.) :  call __detect_npu        ; Test na ptomnost koprocesoru
' 

' Vstup        :  CF = 1  Je instalovn koprocesor
'    CF = 0  Nen instalovn

' Mn registry :  Flags, AX
' 

'@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __detect_npu         ; EXTRN __detect_npu          :PROC :NEAR


Control     DW 00
Maska       EQU 0000111100111111B
Test_1      EQU 0000001100111111B
Test_2      EQU (NOT Test_1) AND Maska


__detect_npu  PROC  NEAR
     int    11h                             ; Nati konfiguraci potae
     test   ax, 0000000000000010B           ; 1=je instalovn
     jnz    NPU_1                           ; Ano, sko ...
No_NPU:
     clc                                    ; CF = 0
     retn                                   ; Nvrt NEAR

;                { Test NPU  }
NPU_1:
     fninit                                 ; Inicializace koprocesoru
     fstcw  word ptr cs:[Control]           ; Uloen stav.slova NK do RAM
     fwait                                  ; Synchronizace
     mov    ax, word ptr cs:[Control]
     and    ax, Maska                       ; Vynulovn nedefinovanch bit
     cmp    ax, Test_1                      ; Test inicializan hodnoty
     jne    No_NPU                          ; Nesouhlas, sko ...

     not    ax                              ; Negace bit stav. slova NK
     mov    word ptr cs:[Control], ax
     fldcw  word ptr cs:[Control]           ; Vloen hodnoty do stav.slova NK
     fstcw  word ptr cs:[Control]           ; Uloen stav.slova NK do RAM
     fwait                                  ; Synchronizace
     mov    ax, word ptr cs:[Control]
     and    ax, Maska                       ; Vynulovn nedefinovanch bit
     cmp    ax, Test_2                      ; Test hodnoty
     jne    No_NPU                          ; Nesouhlas, sko ...

     or     ax, 1000000000000000B           ; Nastav identifikan bit.

;                 { NPU_OK }
NPU_OK:
     stc                                    ; CF = 1
     retn                                   ; Nvrt NEAR
__detect_npu  ENDP

Knihovna_NST32  ENDS
END
