   TITLE Soubor program spolupracujc s ovladaem EMS
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek








   COMMENT @
{

  Nzev souboru  :   EMS.ASM
  Datum prav    :   01.09.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __detect_ems           ; EXTRN __detect_ems          :PROC :NEAR
   PUBLIC __ems_new_page         ; EXTRN __ems_new_page        :PROC :NEAR
   PUBLIC __ems_del_page         ; EXTRN __ems_del_page        :PROC :NEAR
   PUBLIC __mov_page_ems         ; EXTRN __mov_page_ems        :PROC :NEAR

   PUBLIC &__page_ems            ; EXTRN &__page_ems           :WORD
   PUBLIC &__size_ems            ; EXTRN &__size_ems           :WORD
   PUBLIC &__ems_version         ; EXTRN &__ems_version        :BYTE
   PUBLIC &__ems_segment         ; EXTRN &__ems_segment        :WORD


;
;'POZNMKA:
;'   Po instalaci HIMEM.SYS se cel oblast uzamkne a kapacita pamti
;'           se pevede pod sprvu pamti typu XMS. To sam plat pi pouit
;'           EMM386.EXE a zle na jeho nastaven, zda bude LIM-EMS nebo XMS
;'           a nebo oboj ...
;
;'           EXTENDED - pam nad 1MB
;'           EXPANDED - strnkovac pam v 640 KB (EMS)
;'           UMB      - pam mezi 640KB a 1MB
;'           HMA      - 64 KB pamti nad 1MB (pouze 286 a vy)
;'           EMB      - pam nad 1MB
;






;'
;
;' Popis funkce  : Tato procedura testuje ptomnost EMS .
;' 
;
;' Voln(nap.) :  call __detect_ems       ; Test na ptomnost EMS
;' 
;
;' Vstup        :  CL = Verze driveru (BCD slo)
;'    BX = Celkov mnostv volnch strnek EMS
;'                  DX = Celkov mnostv EMS strnek (1. strnka po 16 KB)
;'                  SI = Adr. okna EMS (C800h)

;'                  AH = 00 - Ovlada je OK ...
;'                  CF = 1  Ovlada EMS je instalovn
;'                  CF = 0  Nen instalovno EMS

;
;' Mn registry :  Flags, AX, BX, CX, DX, SI
;' 
;
;'

Test_EMS           DB 'EMMXXXX0'
&__page_ems        DW 00          ; Celkov mnostv EMS strnek (1. strnka po 16 KB)
&__size_ems        DW 00          ; Celkov mnostv volnch strnek EMS
&__ems_version     DB 00          ; Verze XMS v BCD kdu
&__ems_segment     DW 00          ; Adr. okna EMS


__detect_ems  PROC  NEAR
     push   ds es di                        ; Ulo reg.

     mov    ax, 3567h                       ; Zskej adr. INT 67h
     int    21h
     mov    di, 000Ah                       ; Ukazuje na INT 67h (ES:DI)
     mov    si, OFFSET Test_EMS             ; Testovan etzec
     mov    ax, cs
     mov    ds, ax                          ; DS <= CS
     mov    cx, 4
     rep    cmpsw                           ; DS:SI = ES:DI ?
     jne    No_EMS                          ; Ne, sko ...

     mov    ah, 40h                         ; Vra stav EMS
     int    67h
     or     ah, ah                          ; Je ok 0 ?
     jnz    End_EMS                         ; Ne, sko ...

     mov    ah, 41h                         ; Zjisti rmcovou adr. EMS
     int    67h
     or     ah, ah                          ; Je ok 0 ?
     jnz    End_EMS                         ; Ne, sko ...
     mov    word ptr cs:[&__ems_segment], bx; Seg. adr. EMS
     mov    si, bx

     mov    ah, 46h                         ; Zjisti slo verze EMS
     int    67h
     or     ah, ah                          ; Je ok 0 ?
     jnz    End_EMS                         ; Ne, sko ...
     mov    byte ptr cs:[&__ems_version], al; Verze XMS
     mov    cl, al

     mov    ah, 42h                         ; Zjisti celkem/vonch strnek EMS
     int    67h
     or     ah, ah                          ; Je ok 0 ?
     jnz    End_EMS                         ; Ne, sko ...
     mov    word ptr cs:[&__page_ems], dx   ; Celkov mnostv EMS strnek (1. strnka po 16 KB)
     mov    word ptr cs:[&__size_ems], bx   ; Celkov mnostv volnch strnek EMS

;                { Konec testu XMS }
End_EMS:
     pop    di es ds                        ; Obnov reg.
     stc                                    ; CF = 1
     retn                                   ; Nvrt NEAR
;              { EMS nen instalovna }
No_EMS:
     pop    di es ds                        ; Obnov reg.
     clc                                    ; CF = 0
     retn                                   ; Nvrt NEAR

__detect_ems  ENDP






;'
;
;' Popis funkce  : Tato procedura pidl poadovan blok v EMS.
;' 
;
;' Voln(nap.) :  mov  bx, 10             ; Poet strnek (1.str. = 16 KB)
;'    call __ems_new_page     ; Pidl strnku EMS.
;
;' Vstup        :  DX = Komunikan kanl EMS
;'    AH = Chybov hlen (je-li CF=1)
;
;' Mn registry :  Flags, AX, DX
;' 
;
;'

__ems_new_page  PROC  NEAR
     mov    ah, 43h                         ; Vytvo dc slovo a alokuj pam
     int    67h                             ; EMS
     or     ah, ah                          ; Je ve vpodku ?
     jz     EMS_OK                          ; Ano, sko ...
     stc                                    ; CF = 1
     retn                                   ; Nvrt NEAR

EMS_OK:
     clc                                    ; CF = 0
     retn                                   ; Nvrt NEAR
__ems_new_page  ENDP






;'
;
;' Popis funkce  : Tato procedura uvoln poadovan blok v EMS.
;' 
;
;' Voln(nap.) :  mov  dx, Kanl          ; Komunikan kanl EMS
;'    call __ems_del_page     ; Uvolni blok v EMS.
;
;' Vstup        :  AH = Chybov hlen (je-li CF=1)
;' 
;
;' Mn registry :  Flags, AX
;' 
;
;'

__ems_del_page  PROC  NEAR
     mov    ah, 45h                         ; Uvolnil blok EMS
     int    67h                             ; EMS
     or     ah, ah                          ; Je ve vpodku ?
     jz     EMS_OK                          ; Ano, sko ...
     stc                                    ; CF = 1
     retn                                   ; Nvrt NEAR
__ems_del_page  ENDP






;'
;
;' Popis funkce  :  Tato procedura pepne strnku EMS.
;' 
;
;' Voln(nap.) :  mov   dx, Kanl          ; Komunikan kanl EMS
;'    mov   al, 0              ; Fyzick slo bloku (v RAM 0-3)
;'                  mov   bx, 8              ; Log.slo strnky n-1 (kde n je
;'                                           ; celkov poet ovldanch strnek)
;'                  call  __mov_page_ems     ; Pepni strnku EMS
;
;' Vstup        :  AH = Chybov hlen (je-li CF=1)
;' 
;
;' Mn registry :  Flags, AX
;' 
;
;'

__mov_page_ems  PROC  NEAR
     mov    ah, 44h                         ; Mapuj pamt EMS
     int    67h                             ; EMS
     or     ah, ah                          ; Je ve vpodku ?
     jz     EMS_OK                          ; Ano, sko ...
     stc                                    ; CF = 1
     retn                                   ; Nvrt NEAR
__mov_page_ems  ENDP



Knihovna_NST32  ENDS
END
