   TITLE Soubor program spolupracujc s Extended memory
;        Program je napsn podle Progromtorsk Perliky v
;        asopise BAJT 8/92, str. 132

   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek






   COMMENT @
{

  Nzev souboru  :   EXTENDED.ASM
  Datum prav    :   01.09.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __size_extended      ; EXTRN __size_extended       :PROC :NEAR
   PUBLIC __mov_mem_extended   ; EXTRN __mov_mem_extended    :PROC :NEAR
   PUBLIC __mov_extended_mem   ; EXTRN __mov_extended_mem    :PROC :NEAR
   PUBLIC &__size_extended     ; EXTRN &__size_extended      :PROC :NEAR


;' POZNMKA: EXTENDED memory je instalovna pouze od pota 286 a ve.
;'   Je mapovna nad konvenn pam (nad 1MB).
;'           Tato pam je ovldn pomoc BIOSu (INT 15h), nen-li vak
;'           instalovn ovlada pamti (HIMEM, EMM386).
;
;'           Po instalaci HIMEM.SYS se cel oblast uzamkne a kapacita pamti
;'           se pevede pod sprvu pamti typu XMS. To sam plat pi pouit
;'           EMM386.EXE a zle na jeho nastaven, zda bude LIM nebo XMS a
;'           nebo tak oboj ...





;                     Ŀ
;                     {          GDT - Tabulka         }
;                     
INT_15_GDT    DB 8 dup (0)        ; Neprav GDT
              DB 8 dup (0)        ; Toto GDT
;{ Dal adr.}
              DW 8000h            ; Hodnota limitu zdroj. bloku
SRC_LO        DW 0000h            ; 24-bitov adresa
SRC_HI        DB 00h              ;
              DB 10010011B        ; Pstupov prva Read/Write
;'                 
;'                 > Pstup systmu
;'                 > Do segmentu lze zapisovat
;'                 > Offset nesm bt > ne limit
;'                 > Jde o dat.segm.deskriptor
;'                 > Kd nebo dat.segm.deskriptor
;'                > Priorita adt.deskriptoru,
;'                            nejvy priorita pro zen HW
              DW 0000h            ; Vyhrazeno
;{ Dal adr.}
              DW 8000h            ; Hodnota limitu cl. bloku
DESC_LO       DW 0000h            ; 24-bitov adresa
DESC_HI       DB 00h              ;
              DB 10010011B        ; Pstupov prva Read/Write
;'                 
;'                 > Pstup systmu
;'                 > Do segmentu lze zapisovat
;'                 > Offset nesm bt > ne limit
;'                 > Jde o dat.segm.deskriptor
;'                 > Kd nebo dat.segm.deskriptor
;'                > Priorita adt.deskriptoru,
;'                            nejvy priorita pro zen HW
              DW 0000h            ; Vyhrazeno
;{ Dal adr.}
              DB 8 dup (0)        ; Kdov segment pro BIOS
              DB 8 dup (0)        ; Zsobnkov segment pro BIOS












;'
;
;' Popis funkce  : Tato procedura testuje velikost EXTENDED .
;' 
;
;' Voln(nap.) :  call __size_extended    ; Test na ptomnost EXTENDED
;' 
;
;' Vstup        :  AX = Velikost XMS, poet blok po 1KB.
;'    [&__size_xms] <= AX
;
;' Mn registry :  Flags, AX
;' 
;
;'

&__size_extended   DW 00          ; Velikost XMS, poet blok po 1KB.

__size_extended  PROC  NEAR
     mov    ah, 88h
     int    15h
     mov    word ptr cs:[&__size_extended], ax
     retn                                   ; Nvrt NEAR
__size_extended  ENDP






;'
;
;' Popis funkce  : Tato procedura pesune blok z Extended memory do
;'   systmov RAM. Maximln dlka bloku je 32 KB !!!
;
;' Voln(nap.) :  mov  ax, 0012h           ; HI adr. v Extended
;'    mov  bx, 3456h           ; LO adr. v Extended
;'                  mov  cx, 10              ; Dlka bloku (po 1KB)
;'                  mov  di, OFFSET Bufferu  ; ES:DI Adr. dat pro penos
;'                  call __mov_extended_mem  ; Penes blok pamti z Extended do RAM
;
;' Vstup        :  CF = 0 Ve probhlo OK
;'    CF = 1 Nastala chyba
;'                  AH = 01 chyba parity Extended pamti
;'                  AH = 02 dost o peruen, pi operaci
;'                          dolo k chyb a procesor vyvolal peruen
;'                  AH = 03 chyba adresov linky A20
;
;' Mn registry :  Flags, AX, BX, SI, ES
;' 
;
;'

__mov_extended_mem  PROC  NEAR
     mov    byte ptr cs:[SRC_HI], al
     mov    word ptr cs:[SRC_LO], bx

     call   ABS_ADR                         ; Vpoet absol.adr.
     mov    byte ptr cs:[DESC_HI], al
     mov    word ptr cs:[DESC_LO], bx

     call   TRANSPORT                       ; Penes blok pamti

     retn                                   ; Nvrt NEAR
__mov_extended_mem  ENDP






;'
;
;' Popis funkce  : Tato procedura pesune blok do Extended memory .
;'   Maximln dlka bloku je 32 KB !!!
;
;' Voln(nap.) :  mov  ax, 0012h           ; HI adr. v Extended
;'    mov  bx, 3456h           ; LO adr. v Extended
;'                  mov  cx, 10              ; Dlka bloku (po 1KB)
;'                  mov  di, OFFSET Bufferu  ; ES:DI Adr. dat pro penos
;'                  call __mov_mem_extended  ; Penes blok pamti do Extended
;
;' Vstup        :  CF = 0 Ve probhlo OK
;'    CF = 1 Nastala chyba
;'                  AH = 01 chyba parity Extended pamti
;'                  AH = 02 dost o peruen, pi operaci
;'                          dolo k chyb a procesor vyvolal peruen
;'                  AH = 03 chyba adresov linky A20
;
;' Mn registry :  Flags, AX, BX, SI, ES
;' 
;
;'

__mov_mem_extended  PROC  NEAR
     mov    byte ptr cs:[DESC_HI], al
     mov    word ptr cs:[DESC_LO], bx

     call   ABS_ADR                         ; Vpoet absol.adr.
     mov    byte ptr cs:[SRC_HI], al
     mov    word ptr cs:[SRC_LO], bx

     call   TRANSPORT                       ; Penes blok pamti

     retn                                   ; Nvrt NEAR
__mov_mem_extended  ENDP







; Ŀ
; {                  P  O  D  P  R  O  G  R  A  M  Y                      }
; 


;                     Ŀ
;                     {            ABS_ADR             }
;                     
;' Rutina ABS_ADR vypote z hodnot v reg. AX:BX absolutn adresu, kde v
;' registru AX je seg. adr. a v reg. BX relativn adresu, kterou umst do
;' reg. AX, BX jako 32-bitovou hodnotu. Tato abs. (linern) adr. m formt,
;' ktr lze znzornit formou:   AX  0000h
;'                            + BX     0000h
;'                            --------------
;'                            AX:BX 0000000h ===> 32 bit.adr.
;
;' Adresa je absl., tzn. e nem seg. a offset !

ABS_ADR  PROC  NEAR
     push   cx
     mov    ax, es                          ; Systmnov seg.adr.
     xor    bx, bx                          ; BX = 0000
     mov    cx, 0004h                       ; Poet rotac

HI_ADR:sal  ax, 1                           ; Nasouvn nul do bz.adresy
     rcl    bx, 1                           ; Definovn sti vy adr.
     loop   HI_ADR                          ; Skok, je-li co rotovat

     mov    cx, bx                          ; schova sti vy adr.
     mov    bx, di                          ; Systmnov offs.adr.
     add    bx, ax                          ; Piti rel.adr.k ni sti
     adc    cx, 0000h                       ; Piti CF k vy sti adr.
     mov    ax, cx                          ; Pepsn vy sti adr. do reg. AX

     pop    cx
     retn                                   ; Nvrt NEAR
ABS_ADR  ENDP




;                     Ŀ
;                     {    Penos RAM/EXTENDED/RAM     }
;                     
;' Rutina penese blok podle nastaven v tabulce GDT.
;' V CX je dlka bloku ...

TRANSPORT  PROC  NEAR
     push   cs
     pop    es
     mov    si, OFFSET INT_15_GDT
     mov    ah, 87h
     int    15h

     retn                                   ; Nvrt NEAR
TRANSPORT  ENDP



Knihovna_NST32  ENDS
END
