   TITLE Ovld funkce DOSu pro prci se soubory.
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   F_DOS.ASM
  Datum prav    :   01.03.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __open_file          ; EXTRN __open_file           :PROC :NEAR
   PUBLIC __new_file           ; EXTRN __new_file            :PROC :NEAR
   PUBLIC __delete_file        ; EXTRN __delete_file         :PROC :NEAR
   PUBLIC __rename_file        ; EXTRN __rename_file         :PROC :NEAR
   PUBLIC __atribut_file       ; EXTRN __atribut_file        :PROC :NEAR
   PUBLIC __date_time_file     ; EXTRN __date_time_file      :PROC :NEAR
   PUBLIC __point_file         ; EXTRN __point_file          :PROC :NEAR
   PUBLIC __read_file          ; EXTRN __read_file           :PROC :NEAR
   PUBLIC __write_file         ; EXTRN __write_file          :PROC :NEAR
   PUBLIC __close_file         ; EXTRN __close_file          :PROC :NEAR




;'
;
;'Popis funkce  :  Otevi soubor - Open File
;'

;'Voln(nap.) :  mov  al, TypOpen         ; AL = 00 Open pro ten
;'                            ; AL = 01 Open pro zpis
;'                                          ; AL = 02 Open pro ten a zpis
;'                 mov  dx, NAME            ; DS:DX Offset nzvu+cesta a disk
;'                 call __open_file         ; Otevi soubor

;'Vstup        :  CF=1 Nastala chyba,  AX = Kd chyby
;'   BX = slo kanlu

;'Mn registry :  Flags, AX, BX
;'

;'

__open_file  PROC  NEAR
     mov    ah, 3Dh                         ; Open File
     int    21h
     mov    bx, ax                          ; V BX je kanl
     retn                                   ; Nvrat NEAR
__open_file  ENDP






;'

;'Popis funkce  :  Vytvo soubor - New File
;'

;'Voln(nap.) :  mov  cx, ATRIBUTY        ; Atributy souboru
;'   mov  dx, NAME            ; DS:DX Offset nzvu+cesta a disk
;'                 call __new_file          ; Vytvo nov soubor pro zpis

;'Vstup        :  CF=1 Nastala chyba,  AX = Kd chyby
;'   BX = slo kanlu

;'Mn registry :  Flags, AX, BX
;'

;'

__new_file  PROC  NEAR
     mov    ah, 3Ch                         ; New File
     int    21h
     mov    bx, ax                          ; V BX je kanl
     retn                                   ; Nvrat NEAR
__new_file  ENDP






;'
;
;'Popis funkce  :  Sma soubor - Delete File
;'

;'Voln(nap.) :  mov  dx, NAME            ; DS:DX Offset nzvu+cesta a disk
;'   call __delete_file       ; Sma soubor
;'

;'Vstup        :  CF=1 Nastala chyba,  AX = Kd chyby
;'

;'Mn registry :  Flags, AX
;'

;'

__delete_file  PROC  NEAR
     mov    ah, 41h                         ; Delete File
     int    21h
     retn                                   ; Nvrat NEAR
__delete_file  ENDP






;'
;
;'Popis funkce  :  Pejmenuj soubor - Reaname File
;'

;'Voln(nap.) :  mov  dx, NAME            ; DS:DX Offset starho nzvu
;'   mov  di, NewNAME         ; ES:DI Offset novho nzvu
;'                 call __rename_file       ; Pejmenuj soubor

;'Vstup        :  CF=1 Nastala chyba,  AX = Kd chyby
;'

;'Mn registry :  Flags, AX
;'

;'

__rename_file  PROC  NEAR
     mov    ah, 56h                         ; Rename File
     int    21h
     retn                                   ; Nvrat NEAR
__rename_file  ENDP






;'
;
;'Popis funkce  :  Zmna atribut souboru - Atribut File
;'
;
;'Voln(nap.) :  mov  dx, NAME            ; DS:DX Offset nzvu+cesta a disk
;'   mov  cx,0000000000000000B; (jen pro zpis) Atr.souboru
;'                                 
;'                                 > R  Read-only
;'                                 > H  Hidden
;'                                 > S  System
;'                                 >'volume - Nzev disku
;'                                 >'dir    - Adres
;'                                 > A  Archive
;'                                 
;'                                 Nepouito
;
;'                 mov  al, Func            ; AL = 00 Pete nastaven atribut
;'                                          ; AL = 01 Nastavatributy podle CX
;'                 call __atribut_file      ; ti/Zapi atribut souboru
;
;'Vstup        :  CF=1 Nastala chyba,  AX = Kd chyby
;'   CX = kd atributu souboru
;'
;'Mn registry :  Flags, AX, CX
;'
;
;'

__atribut_file  PROC  NEAR
     mov    ah, 43h                         ; Atribute File
     int    21h
     retn                                   ; Nvrat NEAR
__atribut_file  ENDP






;'

;'Popis funkce  :  ti/Nastav datum a as souboru - Date and Time File
;'

;'Voln(nap.) :  mov  al, Typ             ; AL = 00 ti datum a as
;'                            ; AL = 01 Zapi datum a as
;'                 mov  bx, Kanl           ; slo kanlu
;'                 mov  cx, as             ; (pi AL=1) Nov as
;'                 mov  dx, Datum           ; (pi AL=1) Nov datum
;'                 call __date_time_file    ; ti/Zapi datum a as souboru

;'Vstup        :  CF=1 Nastala chyba,  AX = Kd chyby
;'   CX = as                 ; (pi AL=0) Stvajc as souboru
;'                 DX = Datum               ; (pi AL=0) Stvajc datum souboru

;'Mn registry :  Flags, AX, CX, DX
;'

;'Formt dat    :  DX => 0000000  0000  00000
;'           Rok   Msc   Den
;'                        0-119  1-12    0-31

;'                 CX => 00000  000000  00000
;'                      Hodiny  Minuty Sekundy
;'                        0-23   0-59   po 2 sec.0-30

;'

__date_time_file  PROC  NEAR
     mov    ah, 57h                         ; New File
     int    21h
     retn                                   ; Nvrat NEAR
__date_time_file  ENDP






;'

;'Popis funkce  :  Ukazatel v diskovm souboru - Pointer File
;'

;'Voln(nap.) :  mov  bx, Kanl           ; slo kanlu
;'   mov  al, Typ             ; AL = 00 Ukaztel je posunut o
;'                                          ;         CX:DX bajt od zatku
;'                                          ; AL = 01 Ukazatel je posunut o
;'                                          ;         CX:DX bajt od aktuln
;'                                          ;         pozice ukazatele v souboru
;'                                          ; AL = 02 Ukazatel je posunut na
;'                                          ;         konec souboru, plus o
;'                                          ;         CX:DX bajt od konce souboru
;'                 cx:dx                    ; Poet bajt, o kter se m ukazatel posunout
;'                 call __point_file        ; Posu ukazovtko souboru

;'Vstup        :  CF=1 Nastala chyba,  AX = Kd chyby
;'   Nen-li CF=1, pak je v CX:DX nov pozice ukazatele souboru

;'Mn registry :  Flags, AX
;'

;'

__point_file  PROC  NEAR
     mov    ah, 42h                         ; Point File
     int    21h
     retn                                   ; Nvrat NEAR
__point_file  ENDP






;'

;'Popis funkce  :  te data ze souboru - Read File
;'

;'Voln(nap.) :  mov  bx, Kanl           ; slo kanlu
;'   mov  dx, BUFFER          ; DS:DX Adr.,kam se maj data uloit
;'                 mov  cx, 1000            ; Poet bajt, o kter m funkce penst
;'                 call __read_file         ; ti data ze souboru

;'Vstup        :  CF=1 Nastala chyba,  AX = Kd chyby
;'   Nen-li CF=1, pak je v AX poet penesench bajt

;'Mn registry :  Flags, AX
;'

;'

__read_file  PROC  NEAR
     mov    ah, 3Fh                         ; Read File
     int    21h
     retn                                   ; Nvrat NEAR
__read_file  ENDP






;'

;'Popis funkce  :  Zapisuje data do souboru - Write File
;'

;'Voln(nap.) :  mov  bx, Kanl           ; slo kanlu
;'   mov  dx, BUFFER          ; DS:DX Adr.,odkud se maj data st
;'                 mov  cx, 1000            ; Poet bajt, o kter m funkce penst
;'                 call __write_file        ; Zapi data na disk

;'Vstup        :  CF=1 Nastala chyba,  AX = Kd chyby
;'   Nen-li CF=1, pak je v AX poet skuten zapsanch bajt

;'Mn registry :  Flags, AX
;'

;'

__write_file  PROC  NEAR
     mov    ah, 40h                         ; Write File
     int    21h
     retn                                   ; Nvrat NEAR
__write_file  ENDP






;'

;'Popis funkce  :  Zavi soubor - Close File
;'

;'Voln(nap.) :  mov  bx, Kanl           ; slo kanlu
;'   call __close_file        ; Zavi kanl

;'Vstup        :  CF=1 Nastala chyba,  AX = Kd chyby
;'

;'Mn registry :  Flags, AX
;'

;'

__close_file  PROC  NEAR
     mov    ah, 3Eh                         ; Close File
     int    21h
     retn                                   ; Nvrat NEAR
__close_file  ENDP

Knihovna_NST32  ENDS
END
