   TITLE Grafick UTILITY
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   GR_UTIL.ASM
  Datum prav    :   21.09.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __new_color_mod_0    ; EXTRN __new_color_mod_0     :PROC :NEAR
   PUBLIC __write_mod_0        ; EXTRN __write_mod_0         :PROC :NEAR
   PUBLIC __read_mod_0         ; EXTRN __read_mod_0          :PROC :NEAR
   PUBLIC __default_bios_gdc   ; EXTRN __default_bios_gdc    :PROC :NEAR







;'
;
;' Popis funkce  : Nastav Barvu na Video-adi (pouze pro Wirte md 0) (640x480x16)
;'   Na VIDEO-kartu posl 16-bitov hodnoty ...
;
;' Voln(nap.) :  mov  ah, 14              ; Barva
;'    call __new_color_mod_0   ; Nov barva pro Write md 0
;
;' VSTUP        :  DX = 3CFH                ; pro dal OUT - Bit.maska
;' 
;
;' Mn registry :  Flags, DX
;' 
;
;'

__new_color_mod_0  PROC  NEAR
     push   ax                              ; Ulo reg.
;                { Set/Reset - Color }
     mov    dx, 3CEH                        ; Adresn port GDC adie
     xor    al, al                          ; '00H = Set/Reset'
     out    dx, ax                          ; AH = Barva
;                    { Bit.Maska }
     mov    al, 8                           ; 'Naadresuj Bit Mask reg.'
     out    dx, al
     inc    dx                              ; Zvy DX na 3CFH = 9. dat.
     pop    ax
     retn                                   ; Nvrat NEAR
__new_color_mod_0  ENDP






;'
;
;' Popis funkce  : Nastav Video-adi na Wirte md 0. (640x480x16)
;'   Na VIDEO-kartu posl 16-bitov hodnoty ...
;
;' Voln(nap.) :  mov   al, 00             ; 0=Pepis, 1=AND, 2=OR, 3=XOR
;'    call __write_mod_0       ; Md zpisu na VIDEO-adi
;
;' VSTUP        :  ES = A000h - Zatek VIDEO-pamti
;' 
;
;' Mn registry :  Flags, AX, ES
;' 
;
;'

__write_mod_0  PROC  NEAR
     push   dx bx                           ; Ulo reg.
     mov    bx, ax                          ; Ulo BL=Pepis, BH=Barva
;                   { Write Mode 0 }
     mov    dx, 3CEH                        ; Adresn port GDC adie
     mov    ax, 0005H                       ; nastav 'Write Mode 0'
     out    dx, ax                          ; Ulo hodnotu AL do adie
;                   { Data Rotate }
     mov    al, 03H                         ; 'Data Rorate' - GDC
     mov    ah, bl                          ; Ulo BL=Pepis
     shl    ah, 3                           ; Nastav platn bity 3-4
     out    dx, ax                          ; Ulo hodnotu AL do adie a do
;                 { Enable Set/Reset }
     mov    ax, 00F01h                      ; AL: '01H = Enable Set/Reset'
                                            ; AH: 1=Set Reset, 0=Write Bajt
     out    dx, ax                          ; Ulo hodnotu AL do adie
;                   { ES = 0A000h }
     mov    ax, 0A000h                      ; Nastav VIDEO seg.
     mov    es, ax
     pop    bx dx                           ; Obnov reg.
     retn                                   ; Nvrat NEAR
__write_mod_0  ENDP






;'
;
;' Popis funkce  : Nastav Video-adi na Read md 0. (640x480x16)
;'   Na VIDEO-kartu posl 16-bitov hodnoty ...
;
;' Voln(nap.) :  mov   al, 00000000B     ; Bit.rovina ze kter se bude st
;'    call __read_mod_0       ; Md ten z Bit.rovin
;
;' VSTUP        :  ES = A000h - Zatek VIDEO-pamti
;' 
;
;' Mn registry :  Flags, AX, ES
;' 
;
;'

__read_mod_0  PROC  NEAR
     push   dx bx                           ; Ulo reg.
     mov    bx, ax                          ; Ulo BL=Pepis, BH=Barva
;                   { Read Mode 0 }
     mov    dx, 3CEH                        ; Adresn port GDC adie
     mov    ax, 0005H                       ; nastav 'Read Mode 0'
     out    dx, ax                          ; Ulo hodnotu AL do adie
;              { Read Mas Select register }
     mov    al, 04H                         ; 'Read Map Select' - GDC
     mov    ah, bl                          ; Ulo BL=Pepis
     out    dx, ax                          ; Ulo hodnotu AL do adie
;                   { ES = 0A000h }
     mov    ax, 0A000h                      ; Nastav VIDEO seg.
     mov    es, ax
     pop    bx dx                           ; Obnov reg.
     retn                                   ; Nvrat NEAR
__read_mod_0  ENDP






;'
;
;' Popis funkce  : RESET GDC ...  (640x480x16)
;'   Nastav standartn VIDEO-kartu ...
;'                 Na VIDEO-kartu posl 16-bitov hodnoty ...
;
;' Voln(nap.) :  call __default_BIOS_gdc      ; Nastav standartn GDC
;' 
;
;' Mn registry :  Flags
;' 
;
;'

__default_bios_gdc  PROC  NEAR
     push   ax dx                           ; Ulo reg.
     mov    dx, 3CEh                        ; GDC adr.
     mov    ax, 0001h                       ; reg. Enable Set/Reset na 00h
     out    dx, ax
     mov    ax, 0003h                       ; nastav GDC.3 na 00h
     out    dx, ax
     mov    ax, 0005h                       ; nastav Write mod 0
     out    dx, ax
     mov    ax, 0FF08h                      ; nastav Bit.Mask reg.
     out    dx, ax
     pop    dx ax                           ; Obnov reg.
     retn                                   ; Nvrat NEAR
__default_bios_gdc  ENDP



Knihovna_NST32  ENDS
END