   TITLE Ovld a nastavuje rychlost, nebo masku IRQ
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   IRQ.ASM
  Datum prav    :   04.04.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __new_speed_irq_0    ; EXTRN __new_speed_irq_0     :PROC :NEAR
   PUBLIC __read_speed_irq_0   ; EXTRN __read_speed_irq_0    :PROC :NEAR
   PUBLIC __irq_off            ; EXTRN __irq_off             :PROC :NEAR
   PUBLIC __irq_on             ; EXTRN __irq_on              :PROC :NEAR
   PUBLIC __eof_irq            ; EXTRN __eof_irq             :PROC :NEAR
   PUBLIC __irq_2_off          ; EXTRN __irq_2_off           :PROC :NEAR
   PUBLIC __irq_2_on           ; EXTRN __irq_2_on            :PROC :NEAR
   PUBLIC __eof_irq_2          ; EXTRN __eof_irq_2           :PROC :NEAR

   EXTRN __cpu_pause           :PROC :NEAR ; {CPU_PAUS.LIB}



;'
;
;'Popis funkce  :  Nastav rytchlost IRQ 0 - Timer INT 8
;'   Procedura zmn rychlost pro HW generovn IRQ 0

;'Voln(nap.) :  mov  ax, SPEED           ; 1 193 182 Hz / AX = xxx Hz
;'   call __new_speed_irq_0   ; Nastav novou rychlost INT 8

;'Mn registry :  AX
;'

;'

__new_speed_irq_0  PROC  NEAR
     pushf                                  ; Ulo Flags
     cli                                    ; Zaka extern peruen
     push   ax                              ; Ulo reg.

     mov    al, 11111111B                   ; Vechna IRQ
     call   __irq_off                       ; Vypni vybran IRQ

     mov    al, 34h                         ; Nastaven dlie Timeru 0
     out    43h, al
     call   __cpu_pause                     ; asov prodleva CPU (5x JMP $+2)

     pop    ax                              ; LO dlitel frekvence
     out    40h, al
     call   __cpu_pause                     ; asov prodleva CPU (5x JMP $+2)

     xchg   ah, al                          ; HI dlitel frekvence
     out    40h, al
     call   __cpu_pause                     ; asov prodleva CPU (5x JMP $+2)

     call   __irq_on                        ; Obnov pvodn masku IRQ
     call   __eof_irq                       ; Konec IRQ
     popf
     retn                                   ; Nvrat NEAR
__new_speed_irq_0  ENDP






;'
;
;'Popis funkce  :  Peti ryclost generovn IRQ 0 na HW asovai ...
;'   POZOR ! vsledek nen pesn !!!

;'Voln(nap.) :  call __read_speed_irq_0   ; ti stvajc rychlost INT 8
;'   mov  ax, SPEED            ; 1 193 182 Hz / AX = xxx Hz (+/- 1%)

;'Mn registry :  AX CX DX
;'

;'

__read_speed_irq_0  PROC  NEAR
     pushf                                  ; Ulo Flags
     cli                                    ; Zaka extern peruen

     mov    al, 11111111B                   ; Vechna IRQ
     call   __irq_off                       ; Vypni vybran IRQ

     xor    dx, dx
     xor    cx, cx
     mov    al, 00000110B                   ; Nastaven dlie Timeru 0
     out    43h, al

ti_IRQ_0:
     in     al, 40h                         ; ti LO bajt
     mov    ah, al
     in     al, 40h                         ; ti HI bajt
     cmp    ax, dx                          ; Je AX <= DX ?
     jbe    SM_OK                           ; Ano, sko ...
     xchg   dx, ax                          ; Nastav novou (vy hodnotu asovae)

SM_OK:loop  ti_IRQ_0
     mov    ax, dx                          ; Hodnota asovae do AX
     xchg   ah, al

     call   __irq_on                        ; Obnov pvodn masku IRQ
     call   __eof_irq                       ; Konec IRQ
     popf
     retn                                   ; Nvrat NEAR
__read_speed_irq_0  ENDP





;'
;
;'Popis funkce  :  Vypne genrovn vybranch IRQ
;'

;'Voln(nap.) :  mov  al, 00000000B       ; Maska IRQ (AT Master)
;'            
;'                          > IRQ 0 = Systmov asova
;'                          > IRQ 1 = Klvesnice
;'                          > IRQ 2 = Dryh adi IRQ (AT Slave)
;'                          > IRQ 3 = COM 2
;'                          > IRQ 4 = COM 1
;'                          > IRQ 5 = LPT 2
;'                          > IRQ 6 = Flopy Disk
;'                          > IRQ 7 = LPT 1

;'                 call __irq_off           ; Vypni vybran IRQ

;'Vstup        :  BL = Pvodn maska
;'

;'Mn registry :  BX
;'

;'

__irq_off  PROC  NEAR
     pushf                                  ; Ulo Flags
     push   ax

     in     al, 21h                         ; Nati IRQ masku
     mov    bl, al                          ; Ulo masku

     cli                                    ; Zaka extern peruen
     pop    ax
     out    21h, al                         ; Vybran IRQ
     call   __eof_irq                       ; Konec IRQ
     popf                                   ; Obnov Flags
     retn                                   ; Nvrat NEAR
__irq_off  ENDP






;'
;
;'Popis funkce  :  Zapne IRQ vypnut pedelou funkc __irq_off.
;'

;'Voln(nap.) :  mov  bl, 00000000B       ; Maska IRQ
;'            
;'                          > IRQ 0 = Systmov asova
;'                          > IRQ 1 = Klvesnice
;'                          > IRQ 2 = Dryh adi IRQ (AT Slave)
;'                          > IRQ 3 = COM 2
;'                          > IRQ 4 = COM 1
;'                          > IRQ 5 = LPT 2
;'                          > IRQ 6 = Flopy Disk
;'                          > IRQ 7 = LPT 1
;'                 call __irq_on            ; Zapni vybran IRQ

;'

__irq_on  PROC  NEAR
     pushf                                  ; Ulo Flags
     cli                                    ; Zaka extern peruen
     push   ax
     mov    al, bl                          ; Nov (pvodn) maska
     out    21h, al                         ; Zapni IRQ
     call   __eof_irq                       ; Konec IRQ
     pop    ax
     popf                                   ; Ovnov Flags
     ret                                    ; Nvrat
__irq_on  ENDP






;'
;
;'Popis funkce  :  Vyle signl na adi  IRQ o pipravenosti.
;'

;'Voln(nap.) :  call __eof_irq           ; Konec IRQ
;'

;'

__eof_irq  PROC  NEAR
     push   ax
     mov    al, 20h                         ; Resetuj ai ...
     out    20h, al
     pop    ax
     retn                                   ; Nvrat NEAR
__eof_irq  ENDP






;'

;'Popis funkce  :  Vypne genrovn vybranch IRQ (z druhho adie)
;'

;'Voln(nap.) :  mov  al, 00000000B       ; Maska IRQ (AT Master)
;'            
;'                          > IRQ 8 = Real-Time Clock
;'                          > IRQ 9 = Redirected to INT 0Ah
;'                          > IRQ A = Reserved
;'                          > IRQ B = Reserved
;'                          > IRQ C = Reserved
;'                          > IRQ D = Math Coprocessor
;'                          > IRQ E = Hard Disk Controller
;'                          > IRQ F = Reserved
;'                 call __irq_2_off         ; Vypni vybran IRQ (z druhho adie)

;'Vstup        :  BL = Pvodn maska
;'

;'Mn registry :  BX
;'

;'

__irq_2_off  PROC  NEAR
     pushf                                  ; Ulo Flags
     push   ax

     in     al, 0A1h                        ; Nati IRQ masku
     mov    bl, al                          ; Ulo masku

     cli                                    ; Zaka extern peruen
     pop    ax
     out    0A1h, al                        ; Vybran IRQ
     call   __eof_irq_2                     ; Konec IRQ
     popf                                   ; Obnov Flags
     retn                                   ; Nvrat NEAR
__irq_2_off  ENDP






;'
;
;'Popis funkce  :  Zapne IRQ (druhho adie) vypnut pedelou
;'   funkc __irq_2_off.

;'Voln(nap.) :  mov  bl, 00000000B       ; Maska IRQ (AT Master)
;'            
;'                          > IRQ 8 = Real-Time Clock
;'                          > IRQ 9 = Redirected to INT 0Ah
;'                          > IRQ A = Reserved
;'                          > IRQ B = Reserved
;'                          > IRQ C = Reserved
;'                          > IRQ D = Math Coprocessor
;'                          > IRQ E = Hard Disk Controller
;'                          > IRQ F = Reserved
;'                 call __irq_2_on          ; Zapni vybran IRQ (z druhho adie)

;'

__irq_2_on  PROC  NEAR
     pushf                                  ; Ulo Flags
     cli                                    ; Zaka extern peruen
     push   ax
     mov    al, bl                          ; Nov (pvodn) maska
     out    0A1h, al                        ; Zapni IRQ
     call   __eof_irq_2                     ; Konec IRQ
     pop    ax
     popf                                   ; Ovnov Flags
     ret                                    ; Nvrat
__irq_2_on  ENDP






;'
;
;'Popis funkce  :  Vyle signl na adi IRQ (druhho adie) o pipravenosti.
;'

;'Voln(nap.) :  call __eof_irq_2         ; Konec IRQ (druhho adie)
;'

;'

__eof_irq_2  PROC  NEAR
     push   ax
     mov    al, 0A0h                        ; Resetuj ai ...
     out    0A0h, al
     pop    ax
     retn                                   ; Nvrat NEAR
__eof_irq_2  ENDP


Knihovna_NST32  ENDS
END
