   TITLE Tiskne znak na zadannou souadnici
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   OUT_CHAR.ASM
  Datum prav    :   17.09.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __out_char           ; EXTRN __out_char            :PROC :NEAR
   PUBLIC __out_char_gr        ; EXTRN __out_char_gr         :PROC :NEAR
   PUBLIC __new_font           ; EXTRN __new_font            :PROC :NEAR
   PUBLIC __print_char_gr      ; EXTRN __print_char_gr       :PROC :NEAR
   PUBLIC __full_char_gr       ; EXTRN __full_char_gr        :PROC :NEAR
   PUBLIC &__och_row_fnt       ; EXTRN &__och_row_fnt        :WORD
   PUBLIC &__och_size_row      ; EXTRN &__och_size_row       :WORD
   PUBLIC &__och_size_slow     ; EXTRN &__och_size_slow      :WORD
   PUBLIC &__och_fnt           ; EXTRN &__och_fnt            :WORD

   EXTRN __test_position_xy    :PROC :NEAR  ; {TEST_XY.LIB}
   EXTRN &__txy_size_row       :WORD        ; {TEST_XY.LIB}
   EXTRN &__txy_size1_row      :WORD        ; {TEST_XY.LIB}
   EXTRN &__txy_size_slow      :BYTE        ; {TEST_XY.LIB}
   EXTRN __video_offs_adr_t    :PROC :NEAR  ; {V_OFFS_T.ASM}
   EXTRN __new_color_mod_0     :PROC :NEAR  ; {GR_UTIL.LIB}
   EXTRN __write_mod_0         :PROC :NEAR  ; {GR_UTIL.LIB}
   EXTRN __default_bios_gdc    :PROC :NEAR  ; {GR_UTIL.LIB}


&__och_row_fnt     DW 16     ; Vka FNT (pixl)
&__och_size_row    DW 25     ; Max. poet dk
&__och_size_slow   DW 80     ; Max. poet sloupc

&__och_fnt         DW 00     ; Offset font pro Print_Text
                   DW 00     ; Seg. font pro Print_Text






;' 
;' Popis funkce  : Procedura tiskne znak na zadannou souadnici + kontroluje
;'   "dorazy" obrazovky.
;
;' Voln(nap.) :  mov  ah, 14              ; Barva ASCII znaku
;'    mov  al, ASCII znak
;'                  mov  dl, 1               ; Zatek dku    (1-25)
;'                  mov  dh, 1               ; Zatek sloupce  (1-80)
;'                  mov  es, VIDEO           ; Adr. VIDEO pamti
;'                  call __out_char          ; Tiskni znak na souadnice X a Y
;
;' VSTUP        :  DH = Zatek sloupce okna (1-80) + 1
;' 
;
;' Mn registry :  Flags
;' 
;
;' Odvolv se na:  V_OFFS_T.LIB
;'    TEST_XY.LIB
;
;'
__out_char  PROC  NEAR
     push   di                              ; Ulo reg.
     call   __test_position_xy              ; Test souadnic pro tisk
     jc     End_Out_Char                    ; Jsou-li souadnice mimo
                                            ;  obrazovku, sko ...
     call   __video_offs_adr_t              ; Spotej VIDEO-adresu
     stosw                                  ; Tiskni znak
     inc    dh                              ; Zatek sloupce okna (1-80)

End_Out_Char:
     pop    di
     retn                                   ; Nvrat NEAR
__out_char  ENDP






;' 
;' Popis funkce  : Procedura tiskne znak na zadannou souadnici + kontroluje
;'   "dorazy" obrazovky. Dlka FNT je standartn 8 pixl !!!
;
;' Voln(nap.) :  mov  ah, 14              ; Barva ASCII znaku
;'    mov  al, ASCII znak
;'                  mov  dl, 1               ; Zatek dku    (1-25)
;'                  mov  dh, 1               ; Zatek sloupce  (1-80)
;'                  mov  es, VIDEO           ; Adr. VIDEO pamti
;'                  call __out_char_gr       ; Tiskni znak na souadnice X a Y
;
;' VSTUP        :  DH = Zatek sloupce okna (1-80) + 1
;' 
;
;' Mn registry :  Flags
;' 
;
;'@

__out_char_gr  PROC  NEAR
     call   __test_position_xy              ; Test souadnic pro tisk
     jnc    OK_Char                         ; Ne, sko ...
     retn                                   ; Nvrat NEAR

OK_Char:
     push   ax               ; (+15=AH) Barva ASCII znaku
                             ; (+14=AL) ASCII znak
     push   cx               ; (+13=CH)
                             ; (+12=CL)
     push   dx               ; (+11=DH) Zatek sloupce  (1-80)
                             ; (+10=DL) Zatek dku    (1-25)
     push   bx               ; (+09=BH)
                             ; (+08=BL)
     push   bp               ; (+06=BP)
     push   si               ; (+04=SI)
     push   di               ; (+02=DI)
     push   ds               ; (+00=DS)
     mov    bp, sp                          ; Ukazatel na Zsobnk
     mov    ax, cs
     mov    ds, ax                          ; DS <= CS

;   { Spotej poten pozici na monitoru }
     xor    ax, ax                          ; AX = 0000
     mov    al, dl                          ; Zatek dku    (1-25)
     mul    word ptr [&__och_size_slow]     ; Max. poet sloupc  (80)
     mul    word ptr [&__och_row_fnt]       ; Vka FNT (pixl)   (16)
     mov    di, ax                          ; 1. mezivsledek

     xor    bx, bx                          ; BX = 0000
     mov    ax, 0001                        ; Dlka FNT (pixl)   (8)
     mov    bl, byte ptr [bp+11]            ; Zatek sloupce  (1-80)
     mul    bx
     add    di, ax                          ; 2. mezivsledek (kompletn)

;           { Piprav se pro tisk }
     mov    bx, word ptr [&__och_size_slow] ; Max. poet sloupc (80)
     mov    ax, word ptr [bp+14]            ; Barva ASCII znaku
     push   ax                              ; Ulo barvu
     shr    ax, 4                           ; Hi Barva (AH)
     call   __full_char_gr                  ; Vypl podklad znaku

     lds    si, dword ptr cs:[&__och_fnt]   ; Offset font pro Print_Text
     pop    ax                              ; Obnov barvu
     call   __print_char_gr                 ; Tiskni ASCII znak

     pop    ds di si bp bx dx cx ax         ; Obnov reg.
     inc    dh                              ; Zatek sloupce okna (1-80)
     retn                                   ; Nvrat NEAR
__out_char_gr  ENDP





;' 
;' Popis funkce  : Nastav nov FONT pro tisk znak.
;' 
;
;' Voln(nap.) :  mov  ax, 16              ; Vka FNT (pixl)
;'    mov  bx, 25              ; Max. poet dk
;'                  mov  cx, 80              ; Max. poet sloupc
;'                  mov  di, FNT             ; ES:DI Adr. FONTU
;'                  call __new_font          ; Nastav nov FONT
;
;' Mn registry :  Flags
;' 
;
;'

__new_font  PROC NEAR
     mov    word ptr cs:[&__och_row_fnt], ax     ; Vka FNT (pixl)
     mov    word ptr cs:[&__och_size_row], bx    ; Max. poet dk
     mov    word ptr cs:[&__och_size_slow], cx   ; Max. poet sloupc
     mov    word ptr cs:[&__och_fnt], di         ; ES:DI Adr. FONTU
     mov    word ptr cs:[&__och_fnt+2], es
     retn                                        ; Nvrat NEAR
__new_font  ENDP









; Ŀ
; {                  P  O  D  P  R  O  G  R  A  M  Y                      }
; 



;' 
;' Popis funkce  : Vypln barvou z AH podklad pod znakem
;' 
;
;' Voln(nap.) :  mov  ah, 14              ; Barva ASCII znaku
;'    mov  bx, 80              ; Dlka dku
;'                  mov  di, VIDEO           ; Adr. VIDEA
;'                  mov  es, VIDEO           ; Adr. VIDEO pamti
;'                  call __full_char_gr      ; Vupl znak
;
;' Mn registry :  Flags, AX, CX, DX
;' 
;
;'

__full_char_gr  PROC  NEAR
     push   di                              ; Ulo reg.
;           { Tiskni podklad znaku }
     call   __new_color_mod_0               ; Nov barva pro Write md 0
     mov    al, 11111111B                   ; Cel FNT vypl
     out    dx, al                          ; Bit.Maska
     mov    cx, word ptr [&__och_row_fnt]   ; Vka FNT (pixl)

char1:mov   byte ptr es:[di], al            ; Adresuj Bit.ve VIDEO pamti
     add    di, bx                          ; Dal dek
     loop   char1

     pop    di                              ; Obnov reg.
     retn                                   ; Nvrat NEAR
__full_char_gr  ENDP






;' 
;' Popis funkce  : Tiskne znak na obrazovku.
;' 
;
;' Voln(nap.) :  mov  ah, 14              ; Barva ASCII znaku
;'    mov  bx, 80              ; Dlka dku
;'                  mov  di, VIDEO           ; Adr. VIDEA
;'                  mov  es, VIDEO           ; Adr. VIDEO pamti
;'                  call __print_char_gr     ; Tiskni znak na GR.Obrazovku
;
;' Mn registry :  Flags, AX, CX, DX
;' 
;
;'

__print_char_gr  PROC NEAR
     call   __new_color_mod_0               ; Nov barva pro Write md 0

;         { Najdi Bit.Masku v tabulce }
     mul    byte ptr cs:[&__och_row_fnt]    ; Vka FNT (pixl)
     add    si, ax					        ; Adr. na Bit.Masku ASCII znaku
     mov    cx, word ptr cs:[&__och_row_fnt]; Vka FNT (pixl)

;               { Tiskni znak }
char:mov    al, byte ptr [si]               ; DS:SI Bit.Maska ASCII znaku
     out    dx, al                          ; Bit.Maska
     inc    si
     or     byte ptr es:[di], al            ; Adresuj Bit. ve VIDEO-pamti
     add    di, 80
     loop   char

     retn                                   ; Nvrat NEAR
__print_char_gr ENDP


Knihovna_NST32  ENDS
END
