   TITLE Tiskne barevn text na monitor
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   PRINT_T.ASM
  Datum prav    :   20.06.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }

' Popis funkce  :  Print_Text tiskne v textovm reimu text na monitor.
'    Procedura me pro tisk pouvat i uivatelem definovanou
'                  proc. je m tisknout pouze znak na VIDEO ...

'                  dc znaky pro Print_Text:
'                  
'                  9 = Posu kurzor do prava (Tabultor)
'                 10 = Sko na nov dek
'                 13 = Sko na zatek aktulnho dku (zatek dku)
'                  $ = Konec etzce

'                  Print_Text pouv vnitn reg. takto:
'                  
'                  AL = naten ASCI znak
'                  AH = aktuln barva pro tisk
'                  BL = pomocn zatek dku   (1-25)
'                  BH = pomocn zatek sloupce (1-80)
'                  CX = smyky
'                  DL = nov barva znaku podle tabulky
'                  DH = pvodn barva nastaven uivatelem
'                  SI = DS:SI Offset etzce
'                  DI = kopie SETUPu
'                  BP = rezervovno

'                  DS = seg. pro textov data k vytitn
'                  ES = seg. pro VIDEO nebo hledn v tabulkch

'                  Jsou-li v SETUPu vypnuty dc znaky, pak se do CX
'                  vkld dlka etzce.

' Voln(nap.) :  mov  ah, 14              ; Barva etzce
'    mov  dl, 10              ; Zatek dku   (1-25) textu
'                  mov  dh, 1               ; Zatek sloupce (1-80) textu
'                  mov  si, OFFSET TXT      ; DS:SI Adr. zatku textu
'                  call __print_text        ; Tiskni text

' Mn registry :  Flags, ES
' 

' Odvolv se na:  TEST_XY.LIB
'    OUT_CHAR.LIB
'                  KAMEN_AS.LIB
'                  V_SEG.LIB
'                  V_OFFS_T.LIB


'@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __print_text         ; EXTRN __print_text          :PROC :NEAR
   PUBLIC &__pt_setup          ; EXTRN &__pt_setup           :BYTE
   PUBLIC &__pt_color_char     ; EXTRN &__pt_color_char      :BYTE
   PUBLIC &__pt_size_tab       ; EXTRN &__pt_size_tab        :BYTE
   PUBLIC &__pt_proc_user      ; EXTRN &__pt_proc_user       :WORD
   PUBLIC &__pt_char_tab       ; EXTRN &__pt_char_tab        :BYTE
   PUBLIC &__pt_color_tab      ; EXTRN &__pt_color_tab       :BYTE
   PUBLIC &__pt_command        ; EXTRN &__pt_command         :BYTE

   EXTRN __out_char            :PROC :NEAR  ; {OUT_CHAR.LIB}
   EXTRN __out_char_gr         :PROC :NEAR  ; {OUT_CHAR.LIB}
   EXTRN __new_font            :PROC :NEAR  ; {OUT_CHAR.LIB}
   EXTRN __print_char_gr       :PROC :NEAR  ; {OUT_CHAR.LIB}
   EXTRN __full_char_gr        :PROC :NEAR  ; {OUT_CHAR.LIB}
   EXTRN &__och_row_fnt        :WORD        ; {OUT_CHAR.LIB}
   EXTRN &__och_size_row       :WORD        ; {OUT_CHAR.LIB}
   EXTRN &__och_size_slow      :WORD        ; {OUT_CHAR.LIB}
   EXTRN &__och_fnt            :DWORD       ; {OUT_CHAR.LIB}
   EXTRN __kamen_ascii_char    :PROC :NEAR  ; {KAMEN_AS.LIB}
   EXTRN __kamen_ascii_text    :PROC :NEAR  ; {KAMEN_AS.LIB}
   EXTRN &__ka_tab_size_$      :WORD        ; {KAMEN_AS.LIB}
   EXTRN &__ka_kamen_tab       :BYTE        ; {KAMEN_AS.LIB}
   EXTRN &__ka_ascii_tab       :BYTE        ; {KAMEN_AS.LIB}
   EXTRN __video_seg_adr       :PROC :NEAR  ; {V_SEG.LIB}
   EXTRN __test_position_xy    :PROC :NEAR  ; {TEST_XY.LIB}
   EXTRN &__txy_size_row       :WORD        ; {TEST_XY.LIB}
   EXTRN &__txy_size1_row      :WORD        ; {TEST_XY.LIB}
   EXTRN &__txy_size_slow      :BYTE        ; {TEST_XY.LIB}
   EXTRN __video_offs_adr_t    :PROC :NEAR  ; {V_OFFS_T.ASM}
   EXTRN __new_color_mod_0     :PROC :NEAR  ; {GR_UTIL.LIB}
   EXTRN __write_mod_0         :PROC :NEAR  ; {GR_UTIL.LIB}
   EXTRN __default_bios_gdc    :PROC :NEAR  ; {GR_UTIL.LIB}



;        { Nastaven parametr v SETUPu }

&__pt_setup   DB 00000010B        ; Nastaven pro tisk
              ;' 
              ;' > 1 = Pro tisk do okna (pi dcm znaku 13 sko
              ;'              na poten hodnotu zatku tiskku a ne na 0
              ;' > 1 = Pouvat jinou proc. pro tisk def. uivatelem
              ;' > 1 = Peve kd KAMENICKCH na ASCII
              ;' >'1/0 = Pouv program pro identifikaci o zmn barvy
              ;' > 1 = Odpojit z innosti dc znaky (9,10,13,$)
              ;' > 1 = Odpojit tabulku barev z  innosti
              ;' > 1 = Brt barvu z [&__pt_color_char] a ne z AH

&__pt_color_char   DB 0           ; Standartn barva etzce
&__pt_size_tab     DB 8           ; Poet peskakovanch znak pi TAB
&__pt_proc_user    DW OFFSET NAVRAT    ; Offs. pro User proc. pro tisk znaku
&__pt_command      DB 9, 10, 13, '$'   ; dc znaky


Size_$             DW 00          ; Pomocn dlka etzce - dopluje PC
NAVRAT:            RETN           ; Nvrat z przdn User proc.
Text_Pos           DB 0           ; Pomocn zatek sloupce - pro WINDOWS - dopluje PC


&__pt_char_tab     DB '','','','','','','',''      ;Tabulka znak
                   DB '','','','','','','',''      ;pro zmnu barvy
                   DB '','','','','','','',''      ; (od ASCII
                   DB '','','','','','','',''      ;   125 a ve !)

&__pt_color_tab    DB 000,000,000,000,000,000,000,000       ; Tabulka barev
                   DB 000,000,000,000,000,000,000,000
                   DB 000,000,000,000,000,000,000,000
                   DB 000,000,000,000,000,000,000,000

;              { __print_text }
__print_text  PROC  NEAR
     cld                                    ; Zpracovn etzc
     push   ax cx dx bx si di               ; Ulo reg.
     mov    word ptr cs:[Size_$], cx
     push   ax                              ; Ulo barvu

     dec    dl                              ;'KOREKCE' - 1 dek
     dec    dh                              ;'KOREKCE' - 1 sloupec
     mov    bx, dx                          ; Pomocn reg. zatku tisku
     mov    byte ptr cs:[Text_Pos], dh      ; Pomocn zatek sloupce - pro WINDOWS - dopluje PC
     mov    di, word ptr cs:[&__pt_setup]

     call __video_seg_adr                   ; Zjisti VIDEO-adresu a nastav dorazy

;      { Barva z AH nebo [&__pt_color_char] ? }
     pop    dx                              ; Normln barva etzce
     mov    ah, dh                          ; Ulo barvu do pomocnho reg.
     test   di, 0000000010000000B           ; Brt barvu z [&__pt_color_char] ?
     jz     New_ASCII                       ; Ne, sko ...
     mov    ah, byte ptr cs:[&__pt_color_char]   ; Nastav barvu pro vstup
     mov    dh, ah                          ; Ulo barvu pomocnho reg.

;            { Nati ASCII znak }
New_ASCII:
     lodsb                                  ; AL <= DS:[SI]

;          { Test na dc znaky }
     test   di, 0000000000100000B           ; Jsou vypnuty v SETUPu dc znaky ?
     jnz    RZ_OFF                          ; Ano, sko ...

     cmp    al, byte ptr [&__pt_command+1]  ; Je to nov dek ?
     jne    TRZ_1                           ; Ne, sko ...
     inc    bl                              ; Sko o dek n
     jmp    New_ASCII                       ; Nati nov znak

TRZ_1:
     cmp    al, byte ptr [&__pt_command+2]  ; Je to skok na zatek dku ?
     jne    TRZ_2                           ; Ne, sko ...
     xor    bh, bh                          ; Zatek dku
     test   di, 0000000000000010B           ; Tisk pro WINDOWS ?
     jz     New_ASCII                       ; Ne, sko ...
     mov    bh, byte ptr cs:[Text_Pos]      ; Pomocn zatek sloupce - pro WINDOWS - dopluje PC
     jmp    New_ASCII                       ; Nati nov znak

TRZ_2:
     cmp    al, byte ptr [&__pt_command]    ; Je to TABULTOR ?
     jne    TRZ_3                           ; Ne, sko ...
     add    bh, byte ptr cs:[&__pt_size_tab]; Piti k aktulnmu dku dlku TAB
     jmp    New_ASCII                       ; Nati nov znak

TRZ_3:
     cmp    al, byte ptr [&__pt_command+3]  ; Je to konec tisku ?
     jne    PKA_1                           ; Ne, sko ...
Print_End:
     pop    di  si bx dx cx ax              ; Obnov reg.
     retn                                   ; Nvrat NEAR

RZ_OFF:
     dec    word ptr cs:[Size_$]
     jz     Print_End

;           { Pevod Kamenk/ASCII }
PKA_1:push  es di cx
     push   di                              ; Ulo po druh konfiguraci
     push   cs
     pop    es

     test   di, 0000000000001000B           ; Je v SETUPu zapnut pevod ?
     jz     CT_T                            ; Ne, sko ...
     mov    di, OFFSET &__ka_kamen_tab
     mov    cx, word ptr cs:[&__ka_tab_size_$]   ; Dlka tabulky
     repne  scasb                           ; Hledej znak v tabulce
     jne    CT_T                            ; Nen-li tam, sko ...
     add    di, word ptr cs:[&__ka_tab_size_$]   ; Piti dlku tabulky (ukazuje na ASCII)
     mov    al, byte ptr cs:[di-1]          ; Vyber peveden znak

;      { Testuj &__pt_color_tab a New_Color }
CT_T:pop    di                              ; Obnov konfiguraci (po druh)
     test   di, 0000000001000000B           ; Je v SETUPu zapnuta tabulka barev ?
     jnz    No_TC                           ; Ne, sko ...

     test   di, 0000000000010000B           ; Je zapnut tisk v nov barv ?
     jz     TC_1                            ; Ne, sko ...
     cmp    al, dl                          ; Je to identifiktor barvy ?
     jne    No_TC                           ; Ne, sko ...
     mov    ah, dh                          ; Obnov pvodn barvu
     pop    cx di es                        ; Obnov reg.
     and    di, 0000000011101111B           ; Vypni tisk v nov barv
     jmp    New_ASCII                       ; Natni dal znak

TC_1:cmp    al, 125                         ; Je ASCII men jak 125 ?
     jb     No_TC                           ; Ano, sko bez testu ...
     mov    di, OFFSET &__pt_char_tab       ; OFFSET tabulky identifiktor barvy
     mov    cx, 32                          ; Tabulka m 32 poloek
     repne  scasb                           ; Hledej znak v tabulce
     jne    No_TC                           ; Nen-li tam, sko ...

;         { Nastav tisk v nov barv }
     mov    dl, al                          ; Ulo pvodn barvu
     mov    ah, byte ptr cs:[di+31]         ; Vyber novou barvu z Tabulky
     pop    cx di es                        ; Obnov reg.
     or     di, 0000000000010000B           ; Zapni tisk v nov barv
     jmp    New_ASCII                       ; Natni dal znak

;         { Tisk ASCII na obrazovku }
No_TC:pop   cx di es                        ; Obnov reg.
     xchg   bx, dx                          ; Proho BX a DX

     test   di, 0000000000000100B           ; Pou pro tisk uivatelskou proc.
     jz     No_User_OUT                     ; Ne, sko ...
     call   word ptr cs:[&__pt_proc_user]   ; Uivatelsk proc.
     jmp    End_OUT_ASCII                   ; Pesko ...

No_User_OUT:
     call   __out_char                      ; Tiskni znak na souadnice X a Y
End_OUT_ASCII:
     xchg   bx, dx                          ; Vra pvodn parametry
     jmp    New_ASCII                       ; Natni dal znak

__print_text  ENDP

Knihovna_NST32  ENDS
END
