   TITLE Nate ASCII z klvesnice.
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   R_ASCII.ASM
  Datum prav    :   01.08.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }

' Popis funkce  :  __read_ascii nate klvesu z klvesnice.
' 

' Voln(nap.) :  call __read_ascii        ; ekej na ASCII z klvesnice
' 
'

'Vstup        :   AH = SCAN  kd znaku
'    AL = ASCII kd znaku
'                  BL = 00000000B           ; Stav dcch klves
'                       
'                       > Prav SHIFT stisknut
'                       > Lev  SHIFT stisknut
'                       >       Ctrl  stisknut
'                       >       Alt   stisknut
'                       > Scroll Lock aktivn
'                       > Num    Lock aktivn
'                       > Caps   Lock aktivn
'                       > Insert      aktivn

'                  BH = 00000000B           ; Stav rozench dcch klves
'                       
'                       > Lev  Ctrl  stisknut
'                       > Lev  Alt   stisknut
'                       > Prav Ctrl  stisknut
'                       > Prav Alt   stisknut
'                       > Scroll Lock stisknut
'                       > Num    Lock stisknut
'                       > Caps   Lock stisknut
'                       > SysRq       stisknut


' Mn registry :  AX, BX
' 

' Odvolv se na:  PAUSE_MS.LIB
'    CPU_PAUS.LIB
'                  BEEP.LIB

'@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __read_ascii         ; EXTRN __read_ascii          :PROC :NEAR
   PUBLIC __num_key_convert    ; EXTRN __num_key_convert     :PROC :NEAR
   PUBLIC &__ra_setup          ; EXTRN &__ra_setup           :BYTE
   PUBLIC &__ra_proc_user      ; EXTRN &__ra_proc_user       :WORD

   EXTRN  __beep               :PROC :NEAR  ; {BEEP.LIB}
   EXTRN  __pause_ms           :PROC :NEAR  ; {PAUSE_MS.LIB}
   EXTRN  __cpu_pause          :PROC :NEAR  ; {CPU_PAUS.LIB}



;        { Nastaven parametr v SETUPu }
&__ra_setup   DB 00000000B        ; Nastaven pro Read-key
              ;' 
              ;' > 1 = Mezi eknm na klvesu vykonej podprogram ...
              ;' > 1 = ti rozenou klvesnici (IBM AT)
              ;' > 1 = Ppni po stisku klvesy
              ;' > 1 = Uprav stiskl Num-Lock key
              ;' >
              ;' >
              ;' >
              ;' >

&__ra_proc_user    DW OFFSET NAVRAT    ; Offs. pro User proc. pro tisk znaku
NAVRAT:            RETN           ; Nvrat z przdn User proc.



;               { __read_ascii }
__read_ascii  PROC  NEAR
     pushf                                  ; Ulo FLAGs

KEY: mov    ax, 0100h                       ; Funkce pro BIOS INT 16h
     test   byte ptr cs:[&__ra_setup], 00000010B ; Rozen klvesnice ?
     jz     No_RK                                ; Ne, sko ...
     add    ah, 10h                         ; ti ASCII z rozen KEY

;          { Peti stisklou klvesu }
No_RK:
     push   ax ax                           ; Ulo reg.
     int    16h                             ; Nati ASCII ...
     jz     No_KEY                          ; Nen-li znak sko ...

     test   byte ptr cs:[&__ra_setup], 00000100B ; M ppout po stisk KEY ?
     jz     No_PK                                ; Ne, sko ...
     push   cx                              ; Ulo reg.
     mov    bx, 128                         ; Dlka tnu (v 1/64 sekundy)
     mov    cx, 100                         ; Koeficient frekvence
     call   __beep                          ; Generuj tn
     mov    bx, 30                          ; Dlka tnu (v 1/64 sekundy)
     mov    cx, 500                         ; Koeficient frekvence
     call   __beep                          ; Generuj tn
     pop    cx                              ; Obnov reg.

No_PK:pop   ax                              ; Obnov reg.
     inc    ah                              ; AH = 02h nebo 12h
     int    16h                             ; Peti rozenou KEY
     mov    bx, ax                          ; BX <= AX
     pop    ax                              ; Obnov reg.
     dec    ah                              ; AH = 00h nebo 10h
     push   cx                              ; Ulo reg.
     int    16h                             ; Peti KEY v bufferu
     pop    cx                              ; Obnov reg.
     call   __num_key_convert               ; Peve Num KEY
     popf                                   ; Obnov FLAGs
     retn                                   ; Nvrat NEAR


;            { Vykonej User Proc. }
No_KEY:
     pop    ax ax                                ; Obnov reg.
     test   byte ptr cs:[&__ra_setup], 00000001B ; User proc ?
     jz     KEY                                  ; Ne, sko ...

     popf                                        ; Obnov FLAGs
     call   word ptr cs:[&__ra_proc_user]        ; Uivatelsk proc.
     jmp    __read_ascii                         ; Opakuj celu smyku znova ...

__read_ascii  ENDP






;                     Ŀ
;                     {   Spotej akt.pozici v TXT    }
;                     
;' Procedura testuje aktivitu Num-Lock, a podle toho ovld stiskl klvesy.

;' VSTUP:   AX - SCAN a ASCII key
;'     BX - Stav dcch klves

;' VSTUP:  AX - Upraven SCAN a ASCII key
;' 

__num_key_convert  PROC  NEAR

;          { Num-Lock a ed num.key }
     test   bl, 00100000B                   ; Stav dcch klves
     jz     No_Num                          ; Ne, sko ...
     test   byte ptr cs:[&__ra_setup], 00001000B ; Je zapnut pevod ?
     jz     No_Num                          ; Ne, sko ...

     cmp    ax, 532Eh                       ; Del / .
     jne    No_NH_1                         ; Ne, sko ...
     mov    ax, 342Eh                       ; Emulace 0
     retn                                   ; Nvrat NEAR
No_NH_1:
     cmp    ax, 5230h                       ; Insert / 0
     jne    No_NH_2                         ; Ne, sko ...
     mov    ax, 0B30h                       ; Emulace 0
     retn                                   ; Nvrat NEAR
No_NH_2:
     cmp    ax, 4F31h                       ; Insert / 1
     jne    No_NH_3                         ; Ne, sko ...
     mov    ax, 0231h                       ; Emulace 1
     retn                                   ; Nvrat NEAR
No_NH_3:
     cmp    ax, 5032h                       ; Insert / 2
     jne    No_NH_4                         ; Ne, sko ...
     mov    ax, 0332h                       ; Emulace 2
     retn                                   ; Nvrat NEAR
No_NH_4:
     cmp    ax, 5133h                       ; Insert / 3
     jne    No_NH_5                         ; Ne, sko ...
     mov    ax, 0433h                       ; Emulace 3
     retn                                   ; Nvrat NEAR
No_NH_5:
     cmp    ax, 4B34h                       ; Insert / 4
     jne    No_NH_6                         ; Ne, sko ...
     mov    ax, 0534h                       ; Emulace 4
     retn                                   ; Nvrat NEAR
No_NH_6:
     cmp    ax, 4C35h                       ; Insert / 5
     jne    No_NH_7                         ; Ne, sko ...
     mov    ax, 0635h                       ; Emulace 5
     retn                                   ; Nvrat NEAR
No_NH_7:
     cmp    ax, 4D36h                       ; Insert / 6
     jne    No_NH_8                         ; Ne, sko ...
     mov    ax, 0736h                       ; Emulace 6
     retn                                   ; Nvrat NEAR
No_NH_8:
     cmp    ax, 4737h                       ; Insert / 7
     jne    No_NH_9                         ; Ne, sko ...
     mov    ax, 0837h                       ; Emulace 7
     retn                                   ; Nvrat NEAR
No_NH_9:
     cmp    ax, 4838h                       ; Insert / 8
     jne    No_NH_10                        ; Ne, sko ...
     mov    ax, 0938h                       ; Emulace 8
     retn                                   ; Nvrat NEAR
No_NH_10:
     cmp    ax, 4939h                       ; Insert / 9
     jne    No_Num                          ; Ne, sko ...
     mov    ax, 0A39h                       ; Emulace 9
     retn                                   ; Nvrat NEAR

No_Num:
     retn                                   ; Nvrat NEAR

__num_key_convert  ENDP


Knihovna_NST32  ENDS
END
