   TITLE Video-Service, obslun rutinky pro ovldn videa pomoc BIOSu.
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   V_BIOS.ASM
  Datum prav    :   01.08.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __get_video_page     ; EXTRN __get_video_page      :PROC :NEAR
   PUBLIC __set_video_page     ; EXTRN __set_video_page      :PROC :NEAR
   PUBLIC __get_video_mode     ; EXTRN __get_video_mode      :PROC :NEAR
   PUBLIC __get_cursor_pos     ; EXTRN __get_cursor_pos      :PROC :NEAR
   PUBLIC __set_cursor_pos     ; EXTRN __set_cursor_pos      :PROC :NEAR
   PUBLIC __set_cursor_size    ; EXTRN __set_cursor_size     :PROC :NEAR


;'
;
;'Popis funkce  :  Peti aktuln strnku videa.
;'

;'Voln(nap.) :  call __get_video_page    ; Zjisti aktuln strnku Videa
;'

;'Vstup        :  BH = slo strnky
;'

;'Mn registry :  Flags, BX
;'

;'

__get_video_page  PROC  NEAR
     push   ax
     call    __get_video_mode               ; Zjisti aktuln md Videa
     pop    ax
     retn                                   ; Nvrat NEAR
__get_video_page  ENDP






;'
;
;'Popis funkce  :  Nastav novou aktuln strnku videa.
;'

;'Voln(nap.) :  mov  bh, slo strnky
;'   call __set_video_page    ; Nastav novou strnku Videa

;'Mn registry :  Flags
;'

;'

__set_video_page  PROC  NEAR
     push   ax
     mov    ah, 05h                         ; Nastav novoy strnku
     mov    al, bh                          ; Page
     int    10h
     pop    ax
     retn                                   ; Nvrat NEAR
__set_video_page  ENDP






;'
;
;'Popis funkce  :  Peti aktuln md videa.
;'

;'Voln(nap.) :  call __get_video_mode    ; Zjisti aktuln md Videa
;'

;'Vstup        :  AL = Aktuln md
;'   AH = Poet znak na dek
;'                 BH = slo strnky

;'Mn registry :  Flags, AX, BX
;'

;'

__get_video_mode  PROC  NEAR
     mov    ah, 0Fh                         ; Nati aktuln md
     int    10h
     retn                                   ; Nvrat NEAR
__get_video_mode  ENDP








;'
;
;'Popis funkce  :  Peti aktuln nastaven kurzoru.
;'

;'Voln(nap.) :  call __get_cursor_pos    ; Zjisti aktuln pozici kurzoru
;'

;'Vstup        :  CH = Poten linka kurzoru
;'   CL = Koncov linka kurzoru
;'                 DH = dek
;'                 DL = Sloupec

;'Mn registry :  Flags, CX, DX
;'

;'

__get_cursor_pos  PROC  NEAR
     push   ax bx
     call   __get_video_page                ; Zjisti aktuln strnku Videa
     mov    ah, 03h                         ; Peti polohu kurzoru
     int    10h
     pop    bx ax
     retn                                   ; Nvrat NEAR
__get_cursor_pos  ENDP






;'
;
;'Popis funkce  :  Nastav nov pozice kurzoru.
;'

;'Voln(nap.) :  mov  dh, dek           ; Pozice v dku
;'   mov  dl, Sloupec         ; Pozice v sloupci
;'                 call __set_cursor_pos    ; Nastav novou pozici kurzoru

;'Mn registry :  Flags
;'

;'

__set_cursor_pos  PROC  NEAR
     push   ax bx
     call   __get_video_page                ; Zjisti aktuln strnku Videa
     mov    ah, 02h                         ; Nastav polohy kurzoru
     int    10h
     pop    bx ax
     retn                                   ; Nvrat NEAR
__set_cursor_pos  ENDP





;'
;
;'Popis funkce  :  Nastav novou velikost kurzoru.
;'

;'Voln(nap.) :  mov  ch, Po.            ; Poten linka kurzoru
;'   mov  cl, End.            ; Koncov linka kurzoru
;'                 call __set_cursor_size   ; Nastav velikost kurzoru

;'Mn registry :  Flags
;'

;'

__set_cursor_size  PROC  NEAR
     push   ax
     mov    ah, 01h                         ; Nastav velikost kurzoru
     int    10h
     pop    ax
     retn                                   ; Nvrat NEAR
__set_cursor_size  ENDP

Knihovna_NST32  ENDS
END
