   TITLE Soubor program spolupracujc s Extended memory a ovladaem XMS
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek








   COMMENT @
{

  Nzev souboru  :   XMS.ASM
  Datum prav    :   01.09.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __detect_xms         ; EXTRN __detect_xms          :PROC :NEAR
   PUBLIC __emb_new_blok       ; EXTRN __emb_new_blok        :PROC :NEAR
   PUBLIC __emb_del_blok       ; EXTRN __emb_del_blok        :PROC :NEAR
   PUBLIC __emb_blok_info      ; EXTRN __emb_blok_info       :PROC :NEAR
   PUBLIC __emb_lock_blok      ; EXTRN __emb_lock_blok       :PROC :NEAR
   PUBLIC __emb_unlock_blok    ; EXTRN __emb_unlock_blok     :PROC :NEAR
   PUBLIC __mov_blok_xms_tab   ; EXTRN __mov_blok_xms_tab    :PROC :NEAR
   PUBLIC __mov_blok_mem_xms   ; EXTRN __mov_blok_mem_xms    :PROC :NEAR
   PUBLIC __mov_blok_xms_mem   ; EXTRN __mov_blok_xms_mem    :PROC :NEAR

   PUBLIC &__xms_version       ; EXTRN &__xms_version        :WORD
   PUBLIC &__xms_ver_drive     ; EXTRN &__xms_ver_drive      :WORD
   PUBLIC &__size_emb          ; EXTRN &__size_emb           :WORD
   PUBLIC &__size_bloc_emb     ; EXTRN &__size_bloc_emb      :WORD
   PUBLIC &__xms_tab           ; EXTRN &__xms_tab            :WORD
   PUBLIC &__drive_xms_adr     ; EXTRN &__drive_xms_adr      :DWORD


;' POZNMKA: EXTENDED memory je instalovna pouze od pota 286 a ve.
;'   Je mapovna nad konvenn pam (nad 1MB).
;'           Tato pam je ovldn pomoc BIOSu (INT 15h), nen-li vak
;'           instalovn ovlada pamti (HIMEM, EMM386).
;
;'           Po instalaci HIMEM.SYS se cel oblast uzamkne a kapacita pamti
;'           se pevede pod sprvu pamti typu XMS. To sam plat pi pouit
;'           EMM386.EXE a zle na jeho nastaven, zda bude LIM nebo XMS a
;'           nebo tak oboj ...
;
;'           EXTENDED - pam nad 1MB
;'           EXPANDED - strnkovac pam v 640 KB (EMS)
;'           UMB      - pam mezi 640KB a 1MB
;'           HMA      - 64 KB pamti nad 1MB (pouze 286 a vy)
;'           EMB      - pam nad 1MB
;
;'           Ped volnm funkce XMS by mlo bt v zsobnku min.256 bajt
;'           volnho msta !!!


;      Tabulka pro penos mezi pamt a XMS:
;      
&__xms_tab:
       Size_Blok   DD 00000000h   ; 32-bit poet byt pro penos
       Sour_Handle DW 0000h       ; Handle zdrojovho bloku
       Sour_Offset DD 00000000h   ; 32-bitov OFSSET ve zdrojovm bloku
       Dest_Handle DW 0000h       ; Handle clovho bloku
       Dest_Offset DD 00000000h   ; 32-bitov OFSSET v clovm bloku









;'
;
;' Popis funkce  : Tato procedura testuje ptomnost XMS .
;' 
;
;' Voln(nap.) :  call __detect_xms       ; Test na ptomnost XMS
;' 
;
;' Vstup        :  AX = Verze XMS (BCD slo)
;'    BX = Verze driveru (BCD slo)
;'                  CX = Celkov mnostv voln rozen pamti (v KB)
;'                  DX = je-li 0001h, pak existuje HMA, jinak 0000h
;'                  call dword ptr cs:[&__drive_xms_adr]   ; Obslun rutina XMS

;'                  CF = 1  Ovlada XMS je instalovn
;'                  CF = 0  Nen instalovno XMS

;
;' Mn registry :  Flags, AX, BX, DX, ES
;' 
;
;'

&__size_emb        DW 00          ; Celkov mnostv rozen pamti (po 1KB)
&__size_bloc_emb   DW 00          ; Velikost nejvtho bloku EMB, 1KB.
&__xms_version     DW 00          ; Verze XMS
&__xms_ver_drive   DW 00          ; Verze ovladae
&__drive_xms_adr   DW 00          ; Adresa FAR ovladae XMS
                   DW 00

__detect_xms  PROC  NEAR
     mov    ax, 4300h                       ; Test na ptomnost XMS
     int    2Fh
     cmp    al, 80h                         ; Je driver XMS instalovn ?
     jne    No_XMS                          ; Ne, sko ...
     mov    ax, 4310h                       ; Zskej adr. ES:BX ovladae
     int    2Fh
     mov    word ptr cs:[&__drive_xms_adr], bx   ; Ulo adresu ovladae XMS
     mov    word ptr cs:[&__drive_xms_adr+2], es

;                  { Verze XMS }
     xor    ax, ax                          ; Zskej sla verze XMS
     call   dword ptr cs:[&__drive_xms_adr] ; Obslun rutina XMS
     mov    word ptr cs:[&__xms_version], ax     ; Verze XMS
     mov    word ptr cs:[&__xms_ver_drive], bx   ; Verze driveru

;                 { Voln pam }
     push   ax dx
     mov    ax, 0800h                       ; Zjisti velikost EMB (po 1KB blocch)
     call   dword ptr cs:[&__drive_xms_adr] ; Obslun rutina XMS
     cmp    bl, 00                          ; Je ve OK ?
     je     NoErr_XMS                       ; No, sko
     xor    ax, ax                          ; Nastala chyba, nuluj dlku
     mov    dx, ax

NoErr_XMS:
     mov    word ptr cs:[&__size_emb], dx        ; Celkov mnostv rozen pamti (po 1KB)
     mov    cx, dx
     mov    word ptr cs:[&__size_bloc_emb], ax   ; Velikost nejvtho bloku XMS, 1KB.
     pop    dx ax

;                { Konec testu XMS }
End_T_XMS:
     stc                                    ; CF = 1
     retn                                   ; Nvrt NEAR



;              { XMS nen instalovna }
No_XMS:
     xor    ax, ax                          ; Velikost XMS
     clc                                    ; CF = 0
     mov    word ptr cs:[&__size_emb], ax        ; Celkov mnostv rozen pamti (po 1KB)
     mov    word ptr cs:[&__xms_version], ax     ; Verze XMS
     mov    word ptr cs:[&__xms_ver_drive], ax   ; Verze driveru
     mov    word ptr cs:[&__size_bloc_emb], ax   ; Velikost nejvtho bloku XMS, 1KB.
     pop    dx ax
     retn                                   ; Nvrt NEAR

__detect_xms  ENDP






;'
;
;' Popis funkce  : Tato procedura pidl poadovan blok v EMB.
;' 
;
;' Voln(nap.) :  mov  cx, 10             ; Velikost bloku (v KB)
;'    call __emb_new_blok     ; Pidl blok v EMB.
;
;' Vstup        :  DX = Komunikan kanl XMS
;'    BL = Chybov hlen (je-li CF=1)
;
;' Mn registry :  Flags, AX, BX, CX, DX
;' 
;
;'

__emb_new_blok  PROC  NEAR
     mov    dx, cx                          ; Velikost bloku v KB
     mov    ah, 09h                         ; Pidl blok XMS
     call   dword ptr cs:[&__drive_xms_adr] ; Obslun rutina XMS
     cmp    ax, 0001h                       ; Je ve vpodku ?
     je     EMB_OK                          ; Ano, sko ...
     stc                                    ; CF = 1
     retn                                   ; Nvrt NEAR

EMB_OK:
     clc                                    ; CF = 0
     retn                                   ; Nvrt NEAR
__emb_new_blok  ENDP






;'
;
;' Popis funkce  : Tato procedura uvoln poadovan blok v EMB.
;' 
;
;' Voln(nap.) :  mov  dx, Kanl          ; Komunikan kanl XMS
;'    call __emb_del_blok     ; Uvolni blok v EMB.
;
;' Vstup        :  BL = Chybov hlen (je-li CF=1)
;' 
;
;' Mn registry :  Flags, AX, BX, CX
;' 
;
;'

__emb_del_blok  PROC  NEAR
     mov    ah, 0Ah                         ; Uvolnil blok EMB
     call   dword ptr cs:[&__drive_xms_adr] ; Obslun rutina XMS
     cmp    ax, 0001h                       ; Je ve vpodku ?
     je     EMB_OK                          ; Ano, sko ...
     stc                                    ; CF = 1
     retn                                   ; Nvrt NEAR
__emb_del_blok  ENDP







;'
;
;' Popis funkce  : Tato procedura zamkne blok EMB a vrt jeho bzovou
;'   adresu jako 32-bitovou linern adresu. Po dobu, kdy
;'                 je blok zamen je garantovno, e s nm nebude DOS nic
;'                 dlat ani nelze penet ...
;
;' Voln(nap.) :  mov  dx, Kanl          ; Komunikan kanl XMS
;'    call __emb_lock_blok    ; Zamkni blok v EMB.
;
;' Vstup        :  BL = Chybov hlen (je-li CF=1)
;'    DX:BX = 32-bitov linern adr. zamenho bloku
;
;' Mn registry :  Flags, AX, BX, CX, DX
;' 
;
;'

__emb_lock_blok  PROC  NEAR
     mov    ah, 0Ch                         ; Zamkni blok EMB
     call   dword ptr cs:[&__drive_xms_adr] ; Obslun rutina XMS
     cmp    ax, 0001h                       ; Je ve vpodku ?
     je     EMB_OK                          ; Ano, sko ...
     stc                                    ; CF = 1
     retn                                   ; Nvrt NEAR
__emb_lock_blok  ENDP






;'
;
;' Popis funkce  : Tato procedura odemkne blok XMS.
;' 
;
;' Voln(nap.) :  mov  dx, Kanl          ; Komunikan kanl XMS
;'    call __emb_unlock_blok  ; Odemkni blok v EMB.
;
;' Vstup        :  BL = Chybov hlen (je-li CF=1)
;' 
;
;' Mn registry :  Flags, AX, BX, CX
;' 
;
;'

__emb_unlock_blok  PROC  NEAR
     mov    ah, 0Dh                         ; Odemkni blok EMB
     call   dword ptr cs:[&__drive_xms_adr] ; Obslun rutina XMS
     cmp    ax, 0001h                       ; Je ve vpodku ?
     je     EMB_OK                          ; Ano, sko ...
     stc                                    ; CF = 1
     retn                                   ; Nvrt NEAR
__emb_unlock_blok  ENDP







;'
;
;' Popis funkce  : Zjisti informace o vybranm bloku EMB.
;' 
;
;' Voln(nap.) :  mov  dx, Kanl          ; Komunikan kanl XMS
;'    call __emb_blok_info    ; Zjisti informace o bloku v EMB.
;
;' Vstup        :  BL = Chybov hlen (je-li CF=1)
;'    BH = Poet zznam v bloku
;'                  BL = Poet volnch(zbvajcch) rukojet(handle) EMB v systmu
;'                  DX = Dlka bloku EMB
;
;' Mn registry :  Flags, AX, BX, CX, DX
;' 
;
;'

__emb_blok_info  PROC  NEAR
     mov    ah, 0Eh                         ; Zjisti informace o bloku v EMB.
     call   dword ptr cs:[&__drive_xms_adr] ; Obslun rutina XMS
     cmp    ax, 0001h                       ; Je ve vpodku ?
     je     EMB_OK                          ; Ano, sko ...
     stc                                    ; CF = 1
     retn                                   ; Nvrt NEAR
__emb_blok_info  ENDP








;'
;
;' Popis funkce  :  Tato procedura pesune blok z RAM do XMS.
;' 
;'                  Dlka mus bt sud. Je-li adresa ES:DI zarovnna na
;'                  slovo (sud 2,4...), pak to podstatn urychl penos a
;'                  u 386 podstatn stoupne vkon ...
;
;' Voln(nap.) :  mov   dx, Kanl          ; Komunikan kanl XMS
;'    mov   cx, 10             ; Dlka bloku (po 1KB)
;'                  mov   di, OFFSET Bufferu ; ES:DI Adr. dat pro penos
;'                  call  __mov_blok_mem_xms ; Penes blok pamti do XMS
;'                  Dlka mus bt sud. Je-li adresa ES:DI zarovnna na
;'                  slovo (sud 2,4...), pak to podstatn urychl penos a
;'                  u 386 podstatn stoupne vkon ...
;
;' Vstup        :  BL = Chybov hlen (je-li CF=1)
;' 
;
;' Mn registry :  Flags, AX, BX, CX
;' 
;
;'

__mov_blok_mem_xms  PROC  NEAR
     xor    ax, ax                          ; AX = 0000
     and    cx, 1111111111111110B           ; Zarovnej na sud slo
     mov    word ptr cs:[Size_Blok], cx     ; 32-bit poet byt pro penos
     mov    word ptr cs:[Size_Blok+2], ax   ; AX = 0000
     mov    word ptr cs:[Sour_Handle], ax   ; Tab <=0000
     mov    word ptr cs:[Sour_Offset], di
     mov    word ptr cs:[Sour_Offset+2], es
     mov    word ptr cs:[Dest_Handle], dx   ; Komunikan kanl XMS
     mov    word ptr cs:[Dest_Offset], ax   ; Tab <=0000
     mov    word ptr cs:[Dest_Offset+2], ax ; Tab <=0000

     call   __mov_blok_xms_tab              ; Penos bloku XMS podle tabulky
     retn                                   ; Nvrt NEAR
__mov_blok_mem_xms  ENDP






;'
;
;' Popis funkce  :  Tato procedura pesune blok z EMB do RAM.
;' 
;'                  Dlka mus bt sud. Je-li adresa ES:DI zarovnna na
;'                  slovo (sud 2,4...), pak to podstatn urychl penos a
;'                  u 386 podstatn stoupne vkon ...
;
;' Voln(nap.) :  mov   dx, Kanl          ; Komunikan kanl XMS
;'    mov   cx, 10             ; Dlka bloku (po 1KB)
;'                  mov   di, OFFSET Bufferu ; ES:DI Adr. dat pro penos
;'                  call  __mov_blok_emb_mem ; Penes blok z EMB do pamti
;
;' Vstup        :  BL = Chybov hlen (je-li CF=1)
;' 
;
;' Mn registry :  Flags, AX, BX, CX
;' 
;
;'

__mov_blok_xms_mem  PROC  NEAR
     xor    ax, ax                          ; AX = 0000
     and    cx, 1111111111111110B           ; Zarovnej na sud slo
     mov    word ptr cs:[Size_Blok], cx     ; 32-bit poet byt pro penos
     mov    word ptr cs:[Size_Blok+2], ax   ; AX = 0000
     mov    word ptr cs:[Dest_Handle], ax   ; Tab <=0000
     mov    word ptr cs:[Dest_Offset], di
     mov    word ptr cs:[Dest_Offset+2], es
     mov    word ptr cs:[Sour_Handle], dx   ; Komunikan kanl XMS
     mov    word ptr cs:[Sour_Offset], ax   ; Tab <=0000
     mov    word ptr cs:[Sour_Offset+2], ax ; Tab <=0000

     call   __mov_blok_xms_tab              ; Penos bloku XMS podle tabulky
     retn                                   ; Nvrt NEAR
__mov_blok_xms_mem  ENDP


















; Ŀ
; {                  P  O  D  P  R  O  G  R  A  M  Y                      }
; 



;'
;
;' Popis funkce  :  Tato procedura pesune blok pamti podle nastaven
;'    v tabulce. Tabulku si mus nastavit volnan procedura ...
;'
;'                  Dlka mus bt sud. Je-li adresa DS:SI zarovnna na
;'                  slovo (sud 2,4...), pak to podstatn urychl penos a
;'                  u 386 podstatn stoupne vkon ...
;
;' Voln(nap.) :  call  __mov_blok_xms_tab ; Penos bloku XMS podle tabulky
;' 
;'
;' Vstup        :  BL = Chybov hlen (je-li CF=1)
;' 
;
;' Mn registry :  Flags, AX, BX
;' 
;
;'

__mov_blok_xms_tab  PROC  NEAR
     push   ds si                           ; Ulo erg.
     mov    ax, cs                          ; AX <= CS
     mov    ds, ax                          ; DS <= AX
     mov    si, OFFSET &__xms_tab           ; Tabulka parametr
     mov    ah, 0Bh                         ; Penes blok ...
     call   dword ptr cs:[&__drive_xms_adr] ; Obslun rutina XMS
     pop    si ds                           ; Obnov reg.

     cmp    ax, 0001h                       ; Je ve vpodku ?
     je     XMS_BLOK_OK                     ; Ano, sko ...
     stc                                    ; CF = 1
     retn                                   ; Nvrt NEAR

XMS_BLOK_OK:
     clc                                    ; CF = 0
     retn                                   ; Nvrt NEAR
__mov_blok_xms_tab  ENDP



Knihovna_NST32  ENDS
END
